const cartSideC = {
    props: ["items"],
    template: `
    <div class="mx-2 my-2" id="collapseCart">
      <ul class="list-group list-group-flush border-bottom" v-for="(item, index) in cart_data.items">
            <label class="my-auto align-middle" v-if="item.name.length<15" :style="{ color: [colors.title]}" style="overflow: hidden">{{item.name}}</label>
            <label class="my-auto align-middle" v-else :style="{ color: [colors.title]}">{{item.name.substring(0,20)+'..'}}</label>
            <li class="list-group-item list-group-item-action d-flex justify-content-end" :style="{ background: [colors.inner_body]}">
            <div class="d-flex justify-content-between">
                <div class="d-flex">
                <p v-if="!item.discount" class="mx-1 my-auto" :style="{ color: [colors.description]}">kr{{ item.price }},-</p>
                <p v-if="item.discount" class="mx-1 my-auto" :style="{ color: [colors.description]}"><del>kr{{ item.price }},-</del></p>
                <p v-if="item.discount" class="mx-1 my-auto" :style="{ color: [colors.description]}">kr{{ Math.round(item.price*(1-(item.discount/100))) }},-</p>
                </div>
                <p class="text-muted mx-3 my-0" v-if="item.is_item">
                <small>
                    <select class="form-control m-0 my-auto" v-model="item.quantity" @change="onChange(item.quantity, index)">
                      <option v-for="i in 5">{{i}}</option>
                    </select>
                </small>
                </p>
                <p class="mx-3 my-0" v-if="!item.is_item" :style="{ color: [colors.description]}">
                    {{item.duration}}min
                </p>
                <button type="button" class="close my-auto" aria-label="Close" @click="remove(index)">
                  <span aria-hidden="true">&times;</span>
                </button>
            </div>
            </li>
          </ul>
          <h3 class="d-flex justify-content-center my-3" v-if="!cart_data.sum_value">Cart is empty..</h3>
          <div class="d-flex justify-content-between my-3">
            <label class="my-auto" :style="{ color: [colors.title]}"><b>Sum: </b></label>
            <div class="d-flex justify-content-between my-3">
            <p class="mx-3 my-auto" :style="{ color: [colors.title]}"><b>kr{{ cart_data.sum_value }},-</b></p>
            <p class="mx-3 my-auto" v-if="cart_data.sum_time" :style="{ color: [colors.title]}"><b>Tid: {{cart_data.sum_time}}min</b></p>
            </div>
          </div>
        <a class="list-group-item rounded list-group-item-success my-3" data-bs-dismiss="modal" @click="checkout()" :style="{ background: [colors.success], color: [colors.success_text]}" v-if="cart_data.sum_value">Checkout</a>
    </div>
    `,
    // Uses the cookie to figure out what items that is in the cart by using item_id
    // Also gives the option to change quantity, see what item is on discount/sale as well as its new price
    // Total sum updates automatically when changing quantity or removes item
    data: function(){
        return {
            products: product.data,
            colors: color.data,
        }
    },
    created: async function() {
        await loadColors();
        this.colors = color.data;
    },
    methods: {
        remove: async function(item){
            await removeItem(item);
            await getCart();
        },
        checkout: function(){
            router.push("/checkout");
        },
        onChange: async function(quantity, index) {
            await changeQuantity(quantity, index);
            await getCart();
        }
    },
    computed: {
        itemsCart: function() {
            return cart.data.items
        },
        cart_data: function () {
            return cart.data
        },
    },

};