const checkoutMainC = {
    props: [],
    template: `

    <div class="justify-content-center container my-2" style="max-width: 512px">
        <div class="mx-2 my-2">
        <h4 class="my-2" :style="{ color: [colors.title]}">Cart</h4>
        <hr>
          <ul class="list-group list-group-flush border-bottom" v-for="(item, index) in itemsCart">
            <label class="my-auto align-middle" v-if="item.name.length<15" style="overflow: hidden" :style="{ color: [colors.title]}">{{item.name}}</label>
            <label class="my-auto align-middle" v-else :style="{ color: [colors.title]}">{{item.name.substring(0,20)+'..'}}</label>
            <li class="list-group-item list-group-item-action d-flex justify-content-end" :style="{ background: [colors.body]}">
            <div class="d-flex justify-content-between">
                <div class="d-flex">
                <p v-if="!item.discount" class="mx-3 my-auto" :style="{ color: [colors.description]}">kr{{ item.price }},-</p>
                <p v-if="item.discount" class="mx-3 my-auto" :style="{ color: [colors.description]}"><del>kr{{ item.price }},-</del></p>
                <p v-if="item.discount" class="mx-3 my-auto" :style="{ color: [colors.description]}">kr{{ Math.round(item.price*(1-(item.discount/100))) }},-</p>
                </div>
                <p class="text-muted mx-3 my-0" v-if="item.is_item">
                <small>
                    <select class="form-control m-0 my-auto" v-model="item.quantity" @change="onChange(item.quantity, index)">
                      <option v-for="i in 5">{{i}}</option>
                    </select>
                </small>
                </p>
                <p class="mx-3 my-0" v-if="!item.is_item" :style="{ color: [colors.description]}">
                    {{item.duration}}min
                </p>
                <button type="button" class="close my-auto" aria-label="Close" @click="remove(index)">
                  <span aria-hidden="true">&times;</span>
                </button>
            </div>
            </li>
          </ul>
          <div class="d-flex justify-content-between my-3">
                <label class="my-auto" :style="{ color: [colors.title]}"><b>Sum: </b></label>
                <div class="d-flex justify-content-between my-3">
                <div class="d-flex">
                    <p class="mx-3 my-auto" :style="{ color: [colors.title]}" v-if="typeof new_sum_value === 'undefined' || cart_data.sum_value === new_sum_value"><b>kr{{ cart_data.sum_value }},-</b></p>
                    <div class="d-flex" v-else>
                        <p class="mx-3 my-auto" :style="{ color: [colors.title]}" ><b><del>kr{{ cart_data.sum_value }},-</del></b></p>
                        <p class="mx-3 my-auto" :style="{ color: [colors.description]}"><b>kr{{ new_sum_value }},-</b></p>
                    </div>
                </div>
                <p class="mx-3 my-auto" v-if="cart_data.sum_time" :style="{ color: [colors.title]}"><b>Tid: {{cart_data.sum_time}}min</b></p>
                </div>
          </div>
          <div class="mb-3 my-3">
              <label class="form-label" :style="{ color: [colors.title]}"><b>Promo code / Gift card</b></label><br/>
              <form @submit.prevent>
              <div class="btn-group from-control col p-0">
                  <input class="form-control col" placeholder="1a2b3c4d5e6f7g8h" v-model="promo_code" autocapitalize="none">
                  <button class="btn mx-2 rounded col-3" type="submit" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}" @click="applyCode()">Apply</button>
              </div>
              </form>
          </div>
          <div class="justify-content-end w-100">
            <div class="d-flex" v-if="gift_card">
              <a>
                <i class="my-auto bi bi-x-circle" aria-label="Close" @click="removeCard('gift_card')"></i>
              </a>
              <p class="form-label mx-2 my-auto" :style="{ color: [colors.description]}">{{ gift_card }} (rest: {{ gift_card_value }},-) </p>
            </div>
            <div class="d-flex" v-if="discount">
              <a>
                <i class="my-auto bi bi-x-circle" aria-label="Close" @click="removeCard('discount')"></i>
              </a>
              <p class="form-label mx-2 my-auto" :style="{ color: [colors.description]}">{{ discount }} (discount: {{ cart_data.sum_value-new_sum_value-gift_card_spend }},-)</p>
            </div>
          </div>
          <div class="mb-3 my-3" v-if="cart_data.sum_time && possible_dates.length">
              <label class="form-label" :style="{ color: [colors.title]}"><b>Select date</b></label><br/>
              <div class="btn-group from-control col p-0">
                  <select class="form-control m-0 mr-1 col" v-model="selected_date">
                      <option v-for="(option, index) in possible_dates" :value="option">{{ new Date(option).toLocaleString('no-NO', {weekday: 'long', year: 'numeric', month: 'long', day: 'numeric'}) }}</option>
                  </select>
                  <select class="form-control m-0 ml-1 col" v-model="selected_time" @change="updateTimeTo()">
                      <option v-for="(option, index) in possible_times[selected_date].sort()" :value="option">{{option}}</option>
                  </select>
              </div>
          </div>
          <div v-else-if="!checkItem()" class="d-flex justify-content-center">
            <h4 :style="{ color: [colors.title]}">No available spots left, try again later or contact us in the links 
                                                    bottom of the website</h4>
          </div>
          
          <div>
              <div class="mb-3 my-2">
              <h4 class="my-4" :style="{ color: [colors.title]}">Contact information</h4>
              <hr>
                  <label class="form-label" :style="{ color: [colors.description]}">First Name</label>
                  <input class="form-control" placeholder="Ola" v-model="first_name">
              </div>
              <div class="mb-3 my-2">
                  <label class="form-label" :style="{ color: [colors.description]}">Last Name</label>
                  <input class="form-control" placeholder="Nordmann" v-model="last_name">
              </div>
              <div class="mb-3 my-2">
                  <label class="form-label" :style="{ color: [colors.description]}">Email address</label>
                  <input type="email" class="form-control" placeholder="name@example.com" v-model="email">
              </div>
              <div class="mb-3 my-2">
                  <label class="form-label" :style="{ color: [colors.description]}">Phone number</label>
                  <input type="number" class="form-control" placeholder="12345678" v-model="phone">
              </div>
          </div>
          <div class="my-5" v-if="!cart_data.sum_time && checkout_data.shipping_available && cart_data.sum_value">
                <label class="form-label" :style="{ color: [colors.description]}">Shipping</label><br/>
                <select class="form-control" v-model="shipping">
                    <option value="salon" selected>Pick up at salon (0,-)</option>
                    <option value="shipping">Shipping ({{ checkout_data.shipping_price }},-)</option>
                </select>
          </div>
          <div v-if="shipping == 'shipping'">
              <div class="mb-3 my-2">
              <h4 class="my-4" :style="{ color: [colors.title]}">Shipping information</h4>
              <hr>
              </div>
              <div>
                  <label class="form-label" :style="{ color: [colors.description]}">Address</label>
                  <input class="form-control" placeholder="street 1234" v-model="address">
              </div>
              <div class="mb-3 my-2">
                  <label class="form-label" :style="{ color: [colors.description]}">Address 2</label><label class="form-label" :style="{ color: [colors.description]}">(Optional)</label>
                  <input class="form-control" placeholder="street 1234" v-model="address_2">
              </div>
              <div class="mb-3 my-2">
                  <label class="form-label" :style="{ color: [colors.description]}">Postal code</label>
                  <input type="number" class="form-control" placeholder="1234" v-model="postal_code">
              </div>
              <div class="mb-3 my-2">
                  <label class="form-label" :style="{ color: [colors.description]}">City</label>
                  <input class="form-control" placeholder="city" v-model="city">
              </div>
              <div>
                    <label :style="{ color: [colors.description]}">
                        {{ checkout_data.shipping_message }}
                    </label>
              </div>
          </div>
        </div>
        <a v-if="(first_name && last_name && email && phone.length >= 8) && ((shipping === 'salon' && (selected_date && selected_time)) || (address && city && postal_code) || cart_data.sum_time) && Object.entries(cart_data['items']).length"
            class="list-group-item rounded list-group-item-success my-5 d-flex justify-content-center" 
            @click="place_order()" :style="{ background: [colors.success], color: [colors.success_text]}">Book appointment</a>
        <p v-else class="list-group-item rounded list-group-item-secondary disable my-5 d-flex justify-content-center" data-bs-dismiss="modal" :style="{ background: [colors.cancel], color: [colors.cancel_text]}">Place order/appointment</p>
        <div class="m-2">
            <label :style="{ color: [colors.description]}">
                {{ checkout_data.checkout_message }}
            </label>
        </div>
    </div>
    
    <div v-if="ping.success" class="w-100 position-fixed top-5 start-0 mx-auto d-flex justify-content-center" style="z-index: 1200">
        <div class="w-40 alert alert-success d-flex justify-content-center" role="alert" @click="toggleHide()">
            {{ ping.message }}
        </div>
    </div>
    <div v-if="ping.danger" class="w-100 position-fixed top-5 start-0 mx-auto d-flex justify-content-center" style="z-index: 1200">
        <div class="w-40 alert d-flex justify-content-center" :style="{ background: [colors.danger], color:[colors.danger_button_text] }" role="alert" @click="toggleHide()">
            {{ ping.message }}
        </div>
    </div>
    
    `,
    // Checkout page - Takes care of all items in your cart and displays them with its price and discounted price
    // Apply promo codes and get customer information for a booking and eventually a shipping address if necessary
    data: function(){
        return {
            colors: color.data,
            products: product.data,
            checkout_data: checkout_info.data,
            new_cart: {},

            promo_code: "",
            first_name: "",
            last_name: "",
            email: "",
            phone: "",
            address: "",
            address_2: "",
            city: "",
            postal_code: "",

            new_sum_value: undefined,
            discount_value: 0,
            gift_card_value: 0,
            gift_card_spend: 0,
            rest_pay: 0,
            gift_card_id: null,
            gift_card: "",
            discount_id: null,
            discount: "",
            promo: "",
            selected_date: null,
            selected_time: null,
            selected_time_to: null,

            dates: {},
            available_dates: [],

            booked_appointments: {},
            booked_dates: [],

            possible_dates: [],
            possible_times: {},

            shipping: "salon",
            shipping_message: "",
            promo_code_applied: false,
            shipping_provided: false,

            body: "",
        }
    },
    created: async function () {
        await loadColors();
        await getCheckoutInfo();
        await getProducts();
        await getCart();
        await this.getAvailableTimes();
        await this.getBookedTimes();
        this.colors = color.data;
        this.checkout_data = checkout_info.data;
        this.new_cart = this.itemsCart;

    },
    methods: {
        // Removes an item dependent on a item id
        // Reapplies card codes to update the new discounted price
        // Calculates the available times over again due to a change in the sum_time
        remove: async function(item){
            await removeItem(item);
            await getCart();
            await this.applyCode(true);
            await this.calculateAvailableTime();
        },
        onChange: async function(quantity, index) {
            await changeQuantity(quantity, index);
            await getCartTotal();
            await this.applyCode(true);
        },
        // Checks if all items in cart are items
        checkItem() {
            let wanted = Object.entries(this.itemsCart).length;
            let count = 0;
            for (let [key, value] of Object.entries(this.itemsCart)){
                if (value["is_item"]) {
                    count += 1;
                }
            }
            return count === wanted;
        },
        // Remove a applied card
        // Checks which type of card then cancels the changes done to the final price (new_sum_value)
        removeCard(card) {
            if (card==='gift_card') {
                this.gift_card = "";
                this.gift_card_id = null;
                if (this.gift_card_spend) {
                    this.new_sum_value += this.gift_card_spend;
                }
                this.gift_card_spend = 0;
                this.gift_card_value = 0;
            } else if (card==='discount') {
                this.discount = "";
                this.discount_id = null;
                this.new_sum_value += this.discount_value
            }
        },
        // Retrieves available booking dates and time
        async getAvailableTimes() {
            let request = await fetch("/appointments", {
                method: 'GET',
            });
            if (request.status === 200) {
                let response = await request.json();
                this.dates = response;
                this.available_dates = Object.keys(response);
                }
        },
        // Retrieve dates and time for appointments already requested
        // Uses this information to filter out which dates and times are actually available
        // in respect to what the total time of your appointment is
        async getBookedTimes() {
            let request = await fetch("/appointments/booked", {
                method: 'GET',
            });
            if (request.status === 200) {
                let response = await request.json();
                this.booked_dates = Object.keys(response); // List of keys = [yyyy-mm-dd;from;to]
            }
            for (const appointment of this.booked_dates) { // Split date and time from string and add the different times to list in a dict
                let date_array = appointment.split(";");
                if (date_array[0] in this.booked_appointments) { // Checks if key already exist
                    this.booked_appointments[date_array[0]]["from"].push(date_array[1]);
                    this.booked_appointments[date_array[0]]["to"].push(date_array[2]);
                } else {
                    this.booked_appointments[date_array[0]] = {"from": [date_array[1]], "to": [date_array[2]]};
                }
            }
            this.calculateAvailableTime()
        },
        /* Uses the information in the two functions above to calculate which date is available and what time within
         these dates you can select in a segment of 15 min
         You will get the times up for a certain date like:
         sum_time - end_of_day = the latest possible time to select if it did not collide with another orders "end_time"
         From there step down in a segment of 15min and add its time to a list until it collides with a "end_time"
         Step down further until it reaches a "start_time" and continue the process */
        calculateAvailableTime() {
            this.possible_dates = [];
            this.possible_times = {};
            for (const date of this.available_dates) { //Loops through every available date set by admin
                let from = this.dates[date]['time_from'];
                let to = this.dates[date]['time_to'];
                from = this.convertTimeStringToInt(from);
                to = this.convertTimeStringToInt(to);
                let possible_times = [];
                if (date in this.booked_appointments) { // Checks if there is any requested appointments in these dates
                    let unwanted_times = [];  // Array of from/to times
                        for (const [_, value] of Object.entries(this.booked_appointments)) {
                            unwanted_times.push(value['from'].concat(value['to']))
                        }
                    let time_to_values = [];
                    for (let time of this.booked_appointments[date]["to"]) { // Stores the available times as int
                        time_to_values.push(this.convertTimeStringToInt(time))
                    }
                    let time_from_values = [];
                    for (let time of this.booked_appointments[date]["from"]) { // Store the available times as int
                        time_from_values.push(this.convertTimeStringToInt(time))
                    }
                    let temp_to = to;
                    for (let i = to-this.cart_data.sum_time-15; i>=from-15; i-= 15) { // Creates a list that contains all available spots to select with an increment of 15 min
                        if (time_to_values.some(el => el < temp_to && el > i)) {
                            if (time_from_values.includes(i)) {
                                temp_to = i;
                                i -= this.cart_data.sum_time+15 // +15 minutes to ensure a minimum 15min between customers
                            }
                        } else {
                            if (!unwanted_times[0].includes(this.convertIntToTimeString(Math.ceil((i+1)/15)*15))) { // Checks if current value is a from/to time
                                possible_times.push(Math.ceil((i+1)/15)*15);
                            }
                        }
                    }
                    if (possible_times.length > 0) { // If there are any available spots, convert the values to a time string and put it in a final dictionary
                        let possible_times_string = [];
                        for (let value of possible_times.sort()) {
                            possible_times_string.push(this.convertIntToTimeString(value))
                        }
                        this.possible_times[date] = possible_times_string;
                        this.possible_dates.push(date);
                    }
                } else {
                    for (let i = to-this.cart_data.sum_time-15; i>=from-15; i-= 15) { // Creates a list that contains all available spots to select with an increment of 15 min
                        possible_times.push(Math.ceil((i+1)/15)*15)
                    }
                    if (possible_times.length > 0) { // If there are any available spots, convert the values to a time string and put it in a final dictionary
                        let possible_times_string = [];
                        for (let value of possible_times.sort()) {
                            possible_times_string.push(this.convertIntToTimeString(value))
                        }
                        this.possible_times[date] = possible_times_string;
                        this.possible_dates.push(date);
                    }
                }
            }
            this.selected_date = this.possible_dates[0]; // Auto select the first possible date
            this.selected_time = this.possible_times[this.selected_date][0];
            this.updateTimeTo();
        },
        // Converts a time string to an integer (minutes) to make the times comparable
        convertTimeStringToInt(time) {
            if (time) {
                time = time.split(":");
                let hours = parseInt(time[0]);
                let minutes = parseInt(time[1]);
                return hours*60+minutes
            }
        },
        // Turns the time integer to a time string for listing purposes
        convertIntToTimeString(value) {
            let hours = Math.floor(value/60);
            let minutes = (value%60);
            if (minutes === 0) {
                minutes = "00"
            }
            return hours+":"+minutes
        },
        // Sets a value on the time_to variable depending on the time_from and total time of the requested appointment
        updateTimeTo(){
            this.selected_time_to = this.convertIntToTimeString(this.convertTimeStringToInt(this.selected_time)+this.cart_data.sum_time);
            let time_to = this.selected_time_to.split(":");
            if (time_to[1].length < 2) {
                this.selected_time_to = time_to[0] + ":" + "0" + time_to[1]
            }
        },
        // Retrieves data of a gift card dependent on the given promo code
        async getCard(newCard=false) {
            if (newCard) {
                this.promo_code = this.discount;
            }
            if (this.promo_code) {
                let request = await fetch("/gift_card/code/" + this.promo_code, {
                    method: 'GET',
                });
                if (request.status === 200) {
                    let cur_card = await request.json();
                    showMessage("Code applied!");
                    return cur_card;
                } else if (request.status === 403) {
                    showMessage("Invalid code", false);
                }
            }
        },
        // Attempts to retrieve a card with the code in the promo code field
        // If the code exists, check whether its a gift card or discount code
        // Overwrite the previous applied card (of the same type) and apply the new one
        async applyCode(update=false) {
            let promo = await this.getCard();
            if (!promo && update) {
                if (this.discount){
                    promo = await this.getCard(true);
                } else {
                    return
                }
            }
            if (!promo) {
                this.promo_code = "";
                return
            }
            if (promo.card_type === 'discount_code') {
                this.removeCard('discount'); // Removes old data to be overwritten
                this.discount = promo.card_code;
                this.discount_id = promo.card_id;
                this.new_sum_value = 0;
                for (const [key, item] of Object.entries(this.cart_data.items)) {
                    if ((item.is_item && (promo.discount_type === 'all' || promo.discount_type === 'items')) &&
                        (promo.card_category === 'all' || promo.card_category === item.category)) {
                        if (promo.card_discount < item.discount) { // Checks whether the discount on the product itself is larger than the discount code
                            this.new_sum_value += Math.round(item.price*(1-(item.discount/100))*item.quantity) // Get sum of price by (price-item_discount*quantity)
                        } else {
                            this.new_sum_value += Math.round(item.price*(1-(promo.card_discount/100))*item.quantity) // Get sum of price by (price-code_discount*quantity)
                        }
                    } else if ((!item.is_item && (promo.discount_type === 'all' || promo.discount_type === 'service')) &&
                        (promo.card_category === 'all' || promo.card_category === item.category)) {
                        if (promo.card_discount < item.discount) {
                            this.new_sum_value += Math.round(item.price*(1-(item.discount/100))*item.quantity)
                        } else {
                            this.new_sum_value += Math.round(item.price*(1-(promo.card_discount/100))*item.quantity)
                        }
                    } else {
                        this.new_sum_value += Math.round(item.price*(1-(item.discount/100))*item.quantity)
                    }
                }
                this.discount_value = this.cart_data.sum_value - this.new_sum_value;
                this.new_sum_value -= this.gift_card_spend;
                if (this.new_sum_value < 0) {
                    this.gift_card_value -= this.new_sum_value;
                    this.gift_card_spend += this.new_sum_value;
                    this.new_sum_value = 0;
                }
            } else if (promo.card_type === 'gift_card') {
                this.removeCard('gift_card');
                this.gift_card = promo.card_code;
                this.gift_card_value = promo.card_value;
                this.gift_card_id = promo.card_id;
                this.applyGiftCard(this.gift_card)
            }
            this.rest_pay = this.new_sum_value+this.gift_card_spend;
            this.promo_code = "";
        },
        // Overwrites the old gift card with the new one
        applyGiftCard() {
            if (typeof this.new_sum_value === 'undefined') {
                this.new_sum_value = this.cart_data.sum_value;
            }
            if (this.new_sum_value <= this.gift_card_value) {
                this.gift_card_spend = this.new_sum_value;
                this.gift_card_value -= this.gift_card_spend;
                this.new_sum_value = 0;
            } else {
                this.gift_card_spend = this.gift_card_value;
                this.gift_card_value = 0;
                this.new_sum_value -= this.gift_card_spend
            }
        },
        // Places an requested order temporarily in a JSON file (which selectable dates are calculated from)
        // Uses date and time from-to as key to check if spot is already taken in the backend
        // If order only contains item it contains more variable to make the key distinct

        place_order: async function(){
            let key;
            if (this.checkItem()) {
                key = this.selected_date + ";00:00;00:00;" + this.phone + this.email;
            } else {
                key = this.selected_date + ";" + this.selected_time + ";" + this.selected_time_to;
            }
            let request = await fetch("/appointments/booked", {
                    method: 'POST',
                    headers: {"Content-Type": "application/json"},
                    body: JSON.stringify({
                        'key': key,
                        'first_name': this.first_name,
                        'last_name': this.last_name,
                        'mail': this.email,
                        'phone': this.phone,
                        'shipping': this.shipping,
                        'shipping_price': this.checkout_data.shipping_price,
                        'discount_card': this.discount,
                        'discount': this.discount_value,
                        'gift_card': this.gift_card,
                        'gift_card_id': this.gift_card_id,
                        'cart_value': this.cart_data.sum_value,
                        'discounted_value': this.cart_data.sum_value-this.new_sum_value-this.gift_card_spend,
                        'final_value': this.new_sum_value,
                        'gift_card_spend': this.gift_card_spend,
                        'gift_card_rest': this.gift_card_value,
                        'time_from': this.selected_time,
                        'time_to': this.selected_time_to,
                        'address': this.address,
                        'address_2': this.address_2,
                        'city': this.city,
                        'postal_code': this.postal_code,
                        'items': this.itemsCart,
                    })
                });
                if (request.status === 200) {
                    if (this.gift_card) {
                        await updateGiftCardValue(this.gift_card_id, this.gift_card_value);
                    }
                    this.complete();
                } else if (request.status === 403) { // If time you attempt to order is already occupied
                    await this.getAvailableTimes();  // refresh the available times
                    await this.getBookedTimes();
                    this.selected_date = null;
                    this.selected_time = null;
                    showMessage("Something went wrong..", false)
                }
        },

        complete: async function(){
            this.createBody();
            await sendMail("Bestilling", this.body, this.email);

            let date = new Date(this.selected_date).toLocaleString('no-NO', {weekday: 'long', year: 'numeric', month: 'long', day: 'numeric'});
            let notification = "Dato: \n" + date + "\n" + "kl" + this.selected_time + "-" + this.selected_time_to + "\n\n";
            await sendMail("Ny bestilling", notification, contact.data.email);

            let item_id = [];
            for (let item of Object.entries(this.cart_data["items"])){
                item_id.push(item[0])
            }

            let request = await fetch("/products/quantity", {
                    method: 'PUT',
                    headers: {"Content-Type": "application/json"},
                    body: JSON.stringify({
                        'items': item_id,
                    })
                });

            clearCart();
            await getCart();
            router.push("/complete");
    },
        createBody() {
            let date = new Date(this.selected_date).toLocaleString('no-NO', {weekday: 'long', year: 'numeric', month: 'long', day: 'numeric'});
            this.body = "Hei, " + this.first_name + "!\n\n" +
                        "Bestillingen din er registrert og venter på bekreftelse. Du vil motta en ny mail når bestillingen " +
                        "er bekreftet.\n\n";
            this.body += "Dato: \n" + date + "\n";
            this.body += "kl" + this.selected_time + "-" + this.selected_time_to + "\n\n";
            this.body += "Ordre: \n";
            for (let [_, item] of Object.entries(this.itemsCart)) {
                this.body += item.name + " x" + item.quantity +"\n"
            }
            if (this.checkout_data.shipping_price) {
                if (this.new_sum_value) {
                this.body += "\nÅ betale: " + this.new_sum_value + "kr + " + this.checkout_data.shipping_price + "kr frakt\n";
            } else {
                this.body += "\nÅ betale: " + this.cart_data.sum_value + "kr + " + this.checkout_data.shipping_price + "kr frakt\n\n\n";
            }
            } else {
                if (this.new_sum_value) {
                this.body += "\nÅ betale: " + this.new_sum_value + "kr\n";
            } else {
                this.body += "\nÅ betale: " + this.cart_data.sum_value + "kr\n\n\n";
            }
            }


            this.body += "Lurer du på noe? Kontakt oss:\n";
            this.body += "Mobil: " + contact.data.phone + "\n";
            this.body += "Email: " + contact.data.email + "\n";
            this.body += "\n\n - DobbelVstudio"
        }

    },

    computed: {
        itemsCart: function () {
            return cart.data.items
        },
        cart_data: function () {
            return cart.data
        },
        ping: function() {
            return ping.data
        },
    },
};