const mainFooterC = {
    props: [],
    template: `
    <nav class="p-2" :style="{ background: [colors.footer]}" style="z-index: 1000">
    <div class="container-fluid px-4 d-flex justify-content-evenly p-2" style="max-width: 1024px">
        <div class="pt-2 col-md-4 col-lg-3 col-xl-3 mb-md-0">
          <h6 class="text-uppercase fw-bold mb-4" :style="{ color: [colors.title] }">
            Contact
          </h6>
          <div class="d-flex">
            <i class="fas fa-print me-3 bi bi-person" :style="{ color: [colors.title] }"></i>
            <p :style="{ color: [colors.description] }">{{ contact_data.name }}</p>
          </div>
          <div class="d-flex">
            <i class="fas fa-envelope me-3 bi bi-inboxes" :style="{ color: [colors.title] }"></i>
            <a :href="'mailto:'+contact_data.email" :style="{ color: [colors.description] }">
                <p>{{ contact_data.email }}</p>
            </a>
          </div>
          <div class="d-flex">
            <i class="fas fa-phone me-3 bi bi-phone" :style="{ color: [colors.title] }"></i>
            <a :href="'tel:+47'+contact_data.phone" :style="{ color: [colors.description] }">
                <p>+47 {{ contact_data.phone }}</p>
            </a>
          </div>
          <div class="d-flex">
            <i class="fas fa-print me-3 bi bi-signpost" :style="{ color: [colors.title] }"></i>
            <a :href="contact_data.address_link" target="popup" :style="{ color: [colors.description] }">
                <p>{{ contact_data.address }}</p>
            </a>
          </div>
        </div>
        <div class="pt-2 col-md-4 col-lg-3 col-xl-3 mb-md-0">
          <h6 class="text-uppercase fw-bold mb-4" :style="{ color: [colors.title] }">
            Platforms
          </h6>
          <div class="d-flex">
            <i class="fas fa-print me-3" :class="contact_data.platform_1_logo"  :style="{ color: [colors.title] }"></i>
            <a :href="contact_data.platform_1_url" target="popup" :style="{ color: [colors.description] }">
                <p>{{contact_data.platform_1}}</p>
            </a>
          </div>
          <div class="d-flex">
            <i class="fas fa-envelope me-3" :class="contact_data.platform_2_logo" :style="{ color: [colors.title] }"></i>
            <a :href="contact_data.platform_2_url" target="popup" :style="{ color: [colors.description] }">
                <p>{{contact_data.platform_2}}</p>
            </a>
          </div>
          <div class="d-flex">
            <i class="fas fa-envelope me-3" :class="contact_data.platform_3_logo" :style="{ color: [colors.title] }"></i>
            <a :href="contact_data.platform_3_url" target="popup" :style="{ color: [colors.description] }">
                <p>{{contact_data.platform_3}}</p>
            </a>
          </div>
          <div class="d-flex">
            <i class="fas fa-envelope me-3" :href="contact_data.platform_4_url" :class="contact_data.platform_4_logo" :style="{ color: [colors.title] }"></i>
            <a :href="contact_data.platform_3_url" :style="{ color: [colors.description] }" target="popup">
                <p>{{contact_data.platform_4}}</p>
            </a>
          </div>
        </div>
    </div>
    <div class="mx-auto d-flex justify-content-center"  :style="{ color: [colors.description] }">
        {{ contact_data.comment }}
    </div>
    </nav>
    `,
    // Information and contact information in the footer that is fully customizable from the settings tab
data: function(){
        return {
            colors: color.data,
            contact_data: contact.data
        }
    },
    created: async function() {
        await loadColors();
        await getContact();
        this.colors = color.data;
        this.contact_data = contact.data;
    },

};