const mainHeaderC = {
    props: [],
    template: `

    <nav :style="{ background: [colors.header]}" class="navbar navbar-expand navbar-light sticky lg-top top-0 p-0" style="z-index: 1000" >
      <div class="container-fluid px-4" style="max-width: 1024px">
        <div class="navbar-brand col-auto">
            <a><img :src="image" @click="home()" style="max-height: 50px; max-width: 300px"></a>
        </div>
        
          <ul  class="navbar-nav me-auto mb-2 mb-lg-0"></ul>
            <a href="#" class="nav-link" data-bs-toggle="modal" data-bs-target="#cartModal"  :style="{ color: [colors.link_text]}">
              Cart
              <i class="fas fa-print me-3 bi bi-bag" :style="{ color: [colors.link_text]}"></i> 
            </a>
            <div v-if="!state.username">
            <a href="#" class="nav-link" data-bs-toggle="modal" data-bs-target="#loginModal" :style="{ color: [colors.link_text]}">
              Login
            </a>
            </div>
            <div v-else>
            <a class="nav-link" href="#" id="userButton" role="button" data-bs-dismiss="modal" data-bs-toggle="modal" data-bs-target="#userModal" :style="{ color: [colors.link_text]}">
               {{state.username}}
               <i class="fas fa-print me-3 bi bi-person-circle" :style="{ color: [colors.link_text]}"></i> 
            </a>
            </div>
        </div>
    </nav>
   

<!-- Modals -->
<!-- Generates all modals on page from the dictionary in 'settings_menu' in dataStore.js -->
<div v-for="menu in menu_link" class="modal fade" :id="menu.id" tabindex="-1" :aria-labelledby="menu.id+'Label'" aria-hidden="true" style="overflow: auto">
  <div class="modal-dialog">
    <div class="modal-content" :style="{ background: [colors.inner_body]}">
      <div class="modal-header" :style="{ background: [colors.inner_header]}">
        <h4 class="modal-title my-auto" :id="menu.id+'Label'" :style="{ color: [colors.title]}">{{ menu.header }}</h4>
        <i v-if="menu.return" :class="menu.logo" class="icon" style="font-size: 2rem;" data-bs-dismiss="modal" data-bs-toggle="modal" :data-bs-target="'#' + menu.return"></i>
        <i v-else :class="menu.logo" class="icon" style="font-size: 2rem; :hover{cursor: pointer}" data-bs-dismiss="modal" aria-label="Close"></i>
      </div>
      <div class="modal-body" v-if="menu.id == 'loginModal'" :style="{ background: [colors.inner_body]}">
        <login-side></login-side>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'userModal'" :style="{ background: [colors.inner_body]}">
        <user-side></user-side>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'cartModal'" :style="{ background: [colors.inner_body]}">
        <cart-side></cart-side>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'settingsModal'" :style="{ background: [colors.inner_body]}">
        <settings></settings>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'ordersModal'" :style="{ background: [colors.inner_body]}">
        <orders></orders>
      </div> 
      <div class="modal-body" v-else-if="menu.id == 'itemModal'" :style="{ background: [colors.inner_body]}">
        <item></item>
      </div> 
      <div class="modal-body" v-else-if="menu.id == 'editProductsModal'" :style="{ background: [colors.inner_body]}">
        <edit-products></edit-products>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'editDiscountsModal'" :style="{ background: [colors.inner_body]}">
        <edit-discounts></edit-discounts>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'editUsersModal'" :style="{ background: [colors.inner_body]}">
        <edit-users></edit-users>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'editAppearanceModal'" :style="{ background: [colors.inner_body]}">
        <edit-appearance></edit-appearance>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'addProductModal'" :style="{ background: [colors.inner_body]}">
        <add-product></add-product>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'editProductModal'" :style="{ background: [colors.inner_body]}">
        <edit-product></edit-product>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'removeProductModal'" :style="{ background: [colors.inner_body]}">
        <remove-product></remove-product>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'addUserModal'" :style="{ background: [colors.inner_body]}">
        <add-user></add-user>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'editUserModal'" :style="{ background: [colors.inner_body]}">
        <edit-user></edit-user>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'removeUserModal'" :style="{ background: [colors.inner_body]}">
        <remove-user></remove-user>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'addDiscountModal'" :style="{ background: [colors.inner_body]}">
        <add-discount></add-discount>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'addSaleModal'" :style="{ background: [colors.inner_body]}">
        <add-sale></add-sale>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'updateDiscountModal'" :style="{ background: [colors.inner_body]}">
        <update-discount></update-discount>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'removeCodesModal'" :style="{ background: [colors.inner_body]}">
        <remove-codes></remove-codes>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'updateCheckoutModal'" :style="{ background: [colors.inner_body]}">
        <update-checkout></update-checkout>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'updateHeaderModal'" :style="{ background: [colors.inner_body]}">
        <update-header></update-header>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'updateBannerModal'" :style="{ background: [colors.inner_body]}">
        <update-banner></update-banner>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'updateInfoModal'" :style="{ background: [colors.inner_body]}">
        <update-info></update-info>
      </div>
      <div class="modal-body" v-else-if="menu.id == 'updatePaletteModal'" :style="{ background: [colors.inner_body]}">
        <update-palette></update-palette>
      </div>  
    </div>
  </div>
</div>

    `,
    // Header as well as containing the content of every modal on the website
    // menu.id is set in the dictionary in dataStore.js which contains information about
    // modal Title, what type of button is used in the corner and where the button leads to
    // It also decides which modal is showing on screen
data: function(){
        return {
            colors: color.data,
            menu_link: settings_menu,
            image: "",
        }
    },
    created: async function() {
        await loadColors();
        this.colors = color.data;
        let request = await fetch("/header", {
            method: 'GET',
        });
        if (request.status === 200){
            this.image = await request.json();
            }

    },
    methods: {
        home: function(){
            router.push("/home");
        }
    },
    computed: {
        state: function() {
            return user.data
        }
    }
};