const itemC = {
    props: [],
    template: `
    <div class="mx-auto my-2 border rounded my-5" id="collapseCart" v-if="item.img_name" style="max-width: 400px">
        <a>
            <img class="card-img-top" :src="'/static/images/products/'+item.img_name+'.jpg'">
        </a>
        <div class="p-3" :style="{ background: [colors.inner_body]}">
            <h4>
                <a :style="{ color: [colors.title]}">{{ item.title }}</a>
            </h4>
            <p :style="{ color: [colors.description]}">{{ item.description }}</p>
            <p class="d-flex justify-content-end" v-if="!item.is_item" :style="{ color: [colors.description]}"><small>Tid: {{ item.duration }}min</small></p>
        </div>
        
        <div class="card-footer d-flex justify-content-between" :style="{ background: [colors.inner_footer]}">
            <div class="d-flex">
                <p v-if="!item.discount" class="my-auto mx-2" :style="{ color: [colors.title]}">kr{{ item.price }},-</p>
                <p v-if="item.discount" class="my-auto mx-2" :style="{ color: [colors.description]}"><del>kr{{ item.price }},-</del></p>
                <p v-if="item.discount" class="my-auto mx-2" :style="{ color: [colors.title]}">kr{{ Math.round(item.price*(1-(item.discount/100))) }},-</p>
            </div>
            <button type="button" class="btn nav-link" :style="{ background: [colors.cart_button], color: [colors.cart_button_text]}" 
            @click="addToCart(item.item_id)" data-bs-dismiss="modal" @mouseover="hover=1" @mouseleave="hover=-1" :class="{'border border-secondary': hover==1}">
                Add to cart
            </button>
        </div>
    </div>
    `,
    // Popup window after clicking on an item
    // Has the same features, but no text-length limit
    data: function() {
        return {
            // products: product.data,
            copy_url: "",
            cart: cart.data,
            colors: color.data,
            hover: -1
        }
    },
    created: async function () {
        await loadColors();
        this.colors = color.data;
        this.copy_url = location.href.split("#")[0]+"#/product/"+this.item.item_id;
    },
    methods: {
        addToCart: async function(item_id) {
            if (!(item_id in this.cart.items)) {
                appendToCookie('cart', item_id);
                showMessage("Product added to cart!");
            } else if (this.cart.items[item_id].is_item && this.cart.items[item_id].quantity < 5) {
                appendToCookie('cart', item_id);
                showMessage("Product added to cart!");
            } else if (!this.cart.items[item_id].is_item && this.cart.items[item_id].quantity >= 1) {
                showMessage("Already in cart", false);
            } else {
                showMessage("Limit reached", false);
            }
            await getCart();
        },
    },
    computed: {
        item: function () {
            return item_data.data
        },
        products: function(){
            return product.data
        },
    }
};