const itemsMainC = {
    props: [],
    template: `

    <div class="justify-content-center container" style="max-width: 1024px">
      <div class="mx-4 justify-content-center">
      
        <div id="carouselControls" class="carousel slide my-4" data-ride="carousel">
          <div class="carousel-inner rounded" >
          
            <div class="carousel-item rounded" v-for="(banner, index) in banners" :class="{active: index==1}">
<!--              Automatically crops images-->
<!--              <div class="d-block w-100 rounded" :style="{ backgroundImage: 'url(' + 'static/images/headers/' + ''+ banner +'' +')' }" style="max-width:900px; max-height:350px; background-position:center;">&nbsp;</div>-->
              <img class="d-block w-100 rounded" :src="'/static/images/headers/'+banner" alt="header.header_id">
            </div>
            
          </div>
          <a class="carousel-control-prev" href="#carouselControls" role="button" data-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="sr-only">Previous</span>
          </a>
          <a class="carousel-control-next" href="#carouselControls" role="button" data-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="sr-only">Next</span>
          </a>
        </div>
        
        <div class="row m-0">
            <input class="form-control mr-sm-2 col mr-1" type="search" placeholder="Search" v-model="search" aria-label="Search">
            <select class="form-control m-0 col ml-1" v-model="category" @change="clearSearch()">
                <option value="category" selected>All</option>
                <option v-for="(option, index) in categories" :value="option">{{option}}</option>
            </select>
        </div>

        <div class="row my-3">
          <div class="col-lg-4 col-md-6 mb-4" v-for="(item, index) in products_array" v-show="(category == 'category' && item.product_name.toLowerCase().includes(search.toLowerCase())) || (item.category == category && item.product_name.toLowerCase().includes(search.toLowerCase()))">
            <div class="card h-100 mx-auto" style="max-width: 400px" :style="{ background: [colors.body]}">
              <a href="#" data-bs-dismiss="modal" data-bs-toggle="modal" data-bs-target="#itemModal" @click="writeItemData(item.product_id)">
<!--                Automatically crops images-->
<!--                <img class="card-img-top w-100" :style="{ backgroundImage: 'url(' + 'static/images/products/' + ''+ item.img_name +'' + '.jpg' +')' }" style="width:500px; height:400px; background-position:center;">&nbsp;</img>-->
                <img class="card-img-top" :src="'/static/images/products/'+item.img_name+'.jpg'">
              </a>
              <div class="card-body" :style="{ background: [colors.inner_body]}">
                <h4 class="card-title text-dark" data-bs-dismiss="modal" data-bs-toggle="modal" data-bs-target="#itemModal" @click="writeItemData(item.product_id)">
                  <a :style="{ color: [colors.title]}">{{ item.product_name }}</a>
                </h4>
                <p v-if="item.product_description.length<50" class="card-text" :style="{ color: [colors.description]}">{{ item.product_description }}</p>
                <div v-else>
                <span class="card-text" :style="{ color: [colors.description]}">{{ item.product_description.substring(0,50)+'.. ' }}</span>
                <a data-bs-dismiss="modal" href="#" data-bs-toggle="modal" data-bs-target="#itemModal" :style="{ color: [colors.title]}" @click="writeItemData(item.product_id)">Read more</a>
                </div>
                <p class="d-flex justify-content-end" v-if="!item.is_item" :style="{ color: [colors.description]}"><small>Tid: {{ item.duration }}min</small></p>
              </div>
              <div class="card-footer d-flex justify-content-between" :style="{ background: [colors.inner_footer]}">
              <div class="d-flex">
                <p v-if="!item.discount" class="my-auto mx-2" :style="{ color: [colors.title]}">kr{{ item.price }},-</p>
                <p v-if="item.discount" class="my-auto mx-2" :style="{ color: [colors.description]}"><del>kr{{ item.price }},-</del></p>
                <p v-if="item.discount" class="my-auto mx-2" :style="{ color: [colors.title]}">kr{{ Math.round(item.price*(1-(item.discount/100))) }},-</p>
              </div>
                <button type="button" class="btn nav-link" :style="{ background: [colors.cart_button], color: [colors.cart_button_text]}" 
                @click="addToCart(item.product_id)" @mouseover="hover=index" @mouseleave="hover=-1" :class="{'border border-secondary': hover==index}">
                    Add to cart
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div v-if="ping.success" class="w-100 position-fixed top-5 start-0 mx-auto d-flex justify-content-center" style="z-index: 1200">
        <div class="w-40 alert alert-success d-flex justify-content-center" role="alert">
            {{ ping.message }}
        </div>
    </div>
    <div v-if="ping.danger" class="w-100 position-fixed top-5 start-0 mx-auto d-flex justify-content-center" style="z-index: 1200">
        <div class="w-40 alert d-flex justify-content-center" :style="{ background: [colors.danger], color:[colors.danger_button_text] }" role="alert" @click="toggleHide()">
            {{ ping.message }}
        </div>
    </div>
    `,
    data: function(){
        return {
            colors: color.data,
            cart: cart.data,
            banners: [],
            visible: false,
            category: "category",
            search: "",
            hover: -1,
            path_banner: "'static/images/headers/jyveumutfepmusmkhiotndcihelxaeco.jpg'",
            path_item_img: "'/static/images/products/'",
            products_array: [],
        }
    },
    created: async function () {
        await loadColors();
        await getProducts();
        this.colors = color.data;
        let request = await fetch("/banner", {
            method: 'GET',
            });
            if (request.status === 200) {
                this.banners = await request.json();
            }
        this.sort_dict()
    },
    methods: {
        sort_dict(){
            for (const [_, value] of Object.entries(this.products.items)){
                this.products_array.push(value)
            }
            this.products_array.sort(function(a, b) {
              return b.sales - a.sales;
            });
        },

        compareObjects(object1, object2, key) {
          const obj1 = object1[key];
          const obj2 = object2[key];

          if (obj1 < obj2) {
            return -1
          }
          if (obj1 > obj2) {
            return 1
          }
          return 0
        },



        addToCart: async function(item_id) {
            if (!(item_id in this.cart.items)) {
                appendToCookie('cart', item_id);
                showMessage("Product added to cart!");
            } else if (this.cart.items[item_id].is_item && this.cart.items[item_id].quantity < 5) {
                appendToCookie('cart', item_id);
                showMessage("Product added to cart!");
            } else if (!this.cart.items[item_id].is_item && this.cart.items[item_id].quantity >= 1) {
                showMessage("Already in to cart", false);
            } else {
                showMessage("Limit reached", false);
            }
            await getCart();
        },
        // When clicking on an item the data from that item wil be written to the variables used in the popup modal
        // to display the item in full screen with no length limitation of description or title
        writeItemData(item_id) {
            this.changeUrl(item_id);
            item_data.data.item_id = item_id;
            item_data.data.img_name = this.products.items[item_id].img_name;
            item_data.data.title = this.products.items[item_id].product_name;
            item_data.data.description = this.products.items[item_id].product_description;
            item_data.data.is_item = this.products.items[item_id].is_item;
            item_data.data.price = this.products.items[item_id].price;
            item_data.data.duration = this.products.items[item_id].duration;
            item_data.data.discount = this.products.items[item_id].discount;
        },
        // Retrieves the source of the banners used in the top
        getBanners: async function(){
            let request = await fetch("/banner", {
                method: 'GET',
                });
            if (request.status === 200) {
                this.banners = await request.json();
            }
        },
        clearSearch() {
            this.search = "";
        },
        changeUrl(item_id){
              this.copy_url = location.href.split("#")[0]+"#/product/"+item_id;
              history.pushState({}, null, this.copy_url);
            },
    },
    computed:{
        products: function(){
            return product.data
        },
        user_data: function() {
            return user.data
        },
        ping: function() {
            return ping.data
        },
        categories: function() {
            return categories.data.categories
        },
    },
};