const loginSideC = {
    props: [],
    template: `
    <form @submit.prevent :style="{ background: [colors.inner_body]}">
        <p :style="{ color: [colors.danger_text]}" class="d-flex justify-content-center" v-if="danger">Wrong username/password</p>
        <label class="col">Username: <input class="border-1 form-control-lg col" v-model='username' type="text" name="username"/></label><br />
        <label class="col">Password: <input class="border-1 form-control-lg col" v-model='password' type="password" name="password"></label><br />
        <input class="dropdown-item form-control-lg" type="submit" @click="login()" value="Login">
    </form>

    `,
    data() {
        return {
            colors: color.data,
            danger: false,
            success: false,
            username: '',
            password: '',
        }
    },
    created: async function() {
        await loadColors();
        this.colors = color.data;

    },
    methods: {
        // Uses the data in the input fields to attempt a login - if a failed login occurs the "danger" variable wil
        // be set to false and a alerted text will show up over the login
        login: async function () {
            let request = await fetch("/login_attempt", {
            method: 'POST',
            headers: {"Content-Type": "application/json"},
            body: JSON.stringify({'username': this.username, 'password': this.password}),
            });
            if (request.status === 200) {
                showMessage("Login successful");
                await getUsername();
                this.password = "";
                this.danger = false;
                $('#loginModal').modal('hide');
            } else {
                this.danger = true;
                this.password = "";
            }
        }
    },
};


