const ordersC = {
    props: [],
    template: `
    <div v-if="!selected">
        <ul class="list-group">
        <label class="list-group-item" 
        :style="{ background: [colors.settings_list]}" >
            <a href="#" class="nav-link" @click="getTodayAppointments(); selected='today'" :style="{color: [colors.settings_text]}">
                Appointments today
            </a>
        </label>
        <label class="list-group-item" 
        :style="{ background: [colors.settings_list]}" >
            <a href="#" class="nav-link" @click="getUpcomingAppointments(); selected='upcoming'" :style="{color: [colors.settings_text]}">
                Upcoming appointments
            </a>
        </label>
        <label class="list-group-item" :style="{ background: [colors.settings_list]}" v-if="user_data.role == 'admin'">
            <a href="#" class="nav-link" @click="selected='orders'; getAvailableDates()" :style="{color: [colors.settings_text]}">
                Requested appointments
            </a>
        </label>
        <label class="list-group-item" :style="{ background: [colors.settings_list]}" v-if="user_data.role == 'admin'">
            <a class="nav-link" @click="getAvailableDates(); selected = 'available'" :style="{color: [colors.settings_text]}">
                Set available appointments
            </a>
        </label>
        <label class="list-group-item" :style="{ background: [colors.settings_list]}" v-if="user_data.role == 'admin'">
            <a class="nav-link" @click="downloadAppointments()" :style="{color: [colors.settings_text]}">
                Downloads
            </a>
        </label>
        </ul>
    </div>
    
    <div v-if="selected == 'download'">
        <ul class="list-group">
            <label class="list-group-item" :style="{ background: [colors.settings_list]}" >
                <a href="/static/appointments.xls" class="nav-link" @click="selected=false" :style="{color: [colors.settings_text]}" download>
                    Download appointments
                </a>
            </label>
        </ul>
        <ul class="list-group my-2">
            <label class="list-group-item" :style="{ background: [colors.settings_list]}" >
                <a href="/static/backup.zip" class="nav-link" @click="selected=false" :style="{color: [colors.settings_text]}" download>
                    Download database backup
                </a>
            </label>
        </ul>
        <div class="modal-footer">
            <button type="button" class="btn" @click="onReturn(false)" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
        </div>
    </div>
    
    <div v-if="selected == 'available'">
        <ul class="list-group">
            <label class="list-group-item" :style="{ background: [colors.settings_list]}" >
                <a href="#" class="nav-link" @click="selected='new_time'" :style="{color: [colors.settings_text]}">
                    Add available time
                </a>
            </label>
            </ul>
            <ul class="list-group my-2">
            <label v-for="date in available_dates" class="list-group-item" :style="{ background: [colors.settings_list]}" >
                <a href="#" class="nav-link" @click="change_date(date)" :style="{color: [colors.settings_text]}">
                    {{ convertDate(date) }}
                </a>
            </label>
        </ul>
        <div class="modal-footer">
            <button type="button" class="btn" @click="onReturn(false)" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
        </div>
    </div>
    
    <div v-if="selected == 'new_time' || available_dates.includes(selected)" class="col">
        <div>
        <label :style="{ color: [colors.description]}">Date</label>
            <div class="form-group">
                <input class="form-control m-0 col" type="date" v-model="new_date">
            <label v-if="date_today >= new_date" class="justify-content-center" :style="{ color: [colors.danger]}">Invalid date</label>
            </div>
        </div>
        <div v-if="new_date">
        <label :style="{ color: [colors.description]}">From</label>
            <div class="form-group">
                <input class="form-control m-0 col" type="time" step="900" v-model="new_time_from">
            </div>
        </div>
        <div v-if="new_time_from">
        <label :style="{ color: [colors.description]}">To</label>
            <div class="form-group">
                <input @change="checkTime()" class="form-control m-0 col" type="time" step="900" v-model="new_time_to" :min="new_time_from">
            </div>
            <label v-if="new_time_danger && !new_time_to" class="justify-content-center" :style="{ color: [colors.danger_button_text]}">Must be a valid time</label>
        </div>
        <div v-if="available_dates.includes(new_date) && booked_dates.includes(new_date)">
            <label v-if="available_dates.includes(new_date)" class="justify-content-center" :style="{ color: [colors.description]}">Appointments {{ convertDate(new_date) }}</label>
            <ul class="list-group my-2">
                <label class="list-group-item" :style="{ background: [colors.settings_list]}" v-for="(value, key) in booked_appointments">
                    <a href="#" class="nav-link" :style="{color: [colors.settings_text]}" v-if="key.split(';')[0] === new_date">
                       {{ value['first_name'] }}: {{ value['time_from'] }}-{{ value['time_to'] }}
                    </a>
                </label>
            </ul>
        </div>
        <div class="d-flex justify-content-center" v-else>
            <label :style="{ color: [colors.description]}" class="mx-auto">There are no appointments {{ convertDate(new_date) }}</label>
        </div>
        <div class="d-flex justify-content-center" v-if="available_dates.includes(new_date) && new_time_from && new_date && !booked_dates.includes(new_date)">
            <label class="justify-content-center" :style="{ color: [colors.danger_text]}">Date already exists</label>
        </div>
        <div class="modal-footer d-flex justify-content-between">
            <button type="button" class="btn" @click="onReturn('available')" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
            <button v-if="new_time_to && !available_dates.includes(new_date) && date_today < new_date" type="button" class="btn" @click="addAvailableTimes()" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}">Save</button>
            <div v-else-if="available_dates.includes(new_date) && new_time_to && new_time_from && new_date">
                <button type="button" class="btn mx-1" @click="selected = 'remove_available_date'" :style="{ background: [colors.danger], color: [colors.danger_button_text]}">Delete</button>
                <button type="button" class="btn mx-1" @click="updateAvailableDates()" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}">Update</button>
            </div>
            <div v-else-if="available_dates.includes(new_date) && !new_time_to">
                <button type="button" class="btn mx-1 list-group-item-secondary disable btn-outline" :style="{ background: [colors.cancel], color: [colors.cancel_text]}">Delete</button>
                <button type="button" class="btn mx-1 list-group-item-secondary disable btn-outline" :style="{ background: [colors.cancel], color: [colors.cancel_text]}">Update</button>
            </div>
            <button v-else type="button" class="btn list-group-item-secondary disable btn-outline" :style="{ background: [colors.cancel], color: [colors.cancel_text]}">Save</button>
        </div>
    </div>
    <div v-if="selected==='orders'">
        <ul class="list-group my-2" v-if="Object.keys(booked_appointments).length - hidden_appointments > 0">
            <label class="list-group-item"  :style="{ background: [colors.settings_list]}" v-for="(value, key, index) in booked_appointments" v-show="!value['approved']">
            <div v-if="!value['approved']">
                <a href="#" class="nav-link" :style="{color: [colors.settings_text]}" data-bs-toggle="collapse" :data-bs-target="'#a'+index" aria-expanded="false">
                    <div class="d-flex justify-content-between"><h6>{{value["first_name"]}}:</h6> <h6>{{ convertDate(key.split(";")[0]) }}</h6></div>
                </a>
            <div class="accordion accordion-flush" id="requestedInformation">
                <div class="accordion-item list-group-item" :style="{ background: [colors.settings_list]}">
                    <div :id="'a'+index" class="accordion-collapse collapse" :style="{ color: [colors.description]}" aria-labelledby="flush-headingOne" data-bs-parent="#requestedInformation">
                      <div class="d-flex justify-content-between"><p>First name:</p> <p>{{value["first_name"]}}</p></div>
                      <div class="d-flex justify-content-between"><p>Last name:</p> <p>{{value["last_name"]}}</p></div>
                      <div class="d-flex justify-content-between" v-if="value['time_from'] != value['time_to']"><p>Time:</p> <p>{{ value["time_from"] }}-{{ value["time_to"] }}</p></div>
                      <div class="d-flex justify-content-between"><p>Email:</p> <p>{{value["mail"]}}</p></div>
                      <div class="d-flex justify-content-between"><p>Phone:</p> <p>{{value["phone"]}}</p></div>
                      <div class="d-flex justify-content-between"><p>Price:</p> <p>{{value["cart_value"]}}nok</p></div>
                      <div class="d-flex justify-content-between" v-if="value['discounted_value'] != value['cart_value'] && value['discount']"><p>
                        Discount:</p> <p>-{{value['discount']}}nok</p></div>
                      <div class="d-flex justify-content-between" v-if="value['gift_card_spend']"><p>
                        Gift card:</p> <p>-{{value['gift_card_spend']}}nok</p></div>
                      <div class="d-flex justify-content-between" v-if="value['final_value'] || value['gift_card_spend']"><p>
                           To pay:</p> <p>{{value["final_value"]}}nok</p></div>
                      <div class="d-flex justify-content-between" v-else-if="!value['gift_card_spend']"><p>To pay:</p> <p>{{value["cart_value"]}}nok</p> </div>
                      <div class="d-flex justify-content-between" v-else><p>To pay:</p> <p>0nok</p> </div>
                      <div v-if="value['address']">
                      <div class="d-flex justify-content-between"><p>Address:</p> <p>{{ value['address'] }}</p></div>
                      <div class="d-flex justify-content-between" v-if="value['address_2']"><p>Address2:</p> <p>{{ value['address_2'] }}</p></div>
                      <div class="d-flex justify-content-between"><p>Postal code:</p> <p>{{value['postal_code']}}</p></div>
                      <div class="d-flex justify-content-between"><p>City:</p> <p>{{value['city']}}</p></div>
                      <div class="d-flex justify-content-between"><p>Shipping cost:</p> <p>{{ value['shipping_price'] }}</p></div>
                      </div>
                      <p>Products:</p>
                      <div class="d-flex justify-content-between" v-for="(item, key, index) of value['items']"><p>Product #{{index+1}}:</p> <p>{{ item['name'] }}</p></div>
                      <div class=" d-flex justify-content-end">
                          <a type="button" class="btn mx-1 my-auto" @click="approved_key=key; approveAppointment(); customer_data=[value, key]; selected_mail=value['mail']" :style="{ background: [colors.success], color: [colors.button_cancel_text]}">Approve</a>
                          <a type="button" class="btn ml-1 my-auto" @click="selected='deny_appointment'; approved_key=key; selected_mail=value['mail']" :style="{ background: [colors.danger], color: [colors.danger_button_text]}">Deny</a>
                      </div>
                    </div>
                </div>
            </div>
            </div>
            </label>
        </ul>
        <div class="d-flex justify-content-center" v-else>
            <h4 :style="{ color: [colors.title]}">No requested orders..</h4>
        </div>
        <div class="modal-footer">
            <button type="button" class="btn" @click="onReturn(false)" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
        </div>
    </div>
        
    <div v-if="selected=='upcoming'">
        <ul class="list-group my-2" v-if="Object.keys(upcoming_appointments).length">
            <label class="list-group-item"  :style="{ background: [colors.settings_list]}" v-for="(value, key, index) in upcoming_appointments">
                <div>
                    <a href="#" class="nav-link" :style="{color: [colors.settings_text]}" data-bs-toggle="collapse" :data-bs-target="'#b'+index" aria-expanded="false">
                        <div class="d-flex justify-content-between"><h6>{{value["first_name"]}}:</h6> <h6>{{ convertDate(value["date"]) }}</h6></div>
                    </a>
                    <div class="accordion accordion-flush" id="uppcomingAppointmentInfo">
                        <div class="accordion-item list-group-item" :style="{ background: [colors.settings_list]}">
                            <div :id="'b'+index" class="accordion-collapse collapse" :style="{ color: [colors.description]}" aria-labelledby="flush-headingOne" data-bs-parent="#uppcomingAppointmentInfo">
                                <div class="d-flex justify-content-between" v-if="value['time_from'] != value['time_to']"><p>Time:</p> <p>{{ value["time_from"] }}-{{ value["time_to"] }}</p></div>
                                <div class="d-flex justify-content-between"><p>First name:</p> <p>{{value["first_name"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Last name:</p> <p>{{value["last_name"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Mail:</p> <p>{{value["mail"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Phone:</p> <p>{{value["phone"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Date:</p> <p>{{ convertDate(value["date"]) }}</p></div>
                                <div class="d-flex justify-content-left"><p>Products:</p></div>
                                <div class="d-flex justify-content-left" v-for="(item, index) in value['items'].substring(1, value['items'].length-1).split(',')"><p>{{item.substring(1, item.length-1)}}</p></div>
                                <div class=" d-flex justify-content-end">
                                    <a type="button" class="btn ml-1 my-auto" @click="selected='cancel_appointment'; approved_key=key; selected_mail=value['mail']" :style="{ background: [colors.danger], color: [colors.danger_button_text]}">Cancel</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </label>
        </ul>
        <div class="d-flex justify-content-center" v-else>
            <h4 :style="{ color: [colors.title]}">No upcoming appointments</h4>
        </div>
    
        <div class="modal-footer">
            <button type="button" class="btn" @click="onReturn(false)" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
        </div>
    </div>
    
    <div v-if="selected=='today'">
        <ul class="list-group my-2" v-if="Object.keys(today_appointments).length">
            <label class="list-group-item"  :style="{ background: [colors.settings_list]}" v-for="(value, key, index) in today_appointments">
                <div>
                    <a href="#" class="nav-link" :style="{color: [colors.settings_text]}" data-bs-toggle="collapse" :data-bs-target="'#c'+index" aria-expanded="false">
                       <div class="d-flex justify-content-between"><h6>{{value["first_name"]}}:</h6> <h6>{{ convertDate(value["date"]) }}</h6></div>
                    </a>
                    <div class="accordion accordion-flush" id="todayAppointmentInfo">
                        <div class="accordion-item list-group-item" :style="{ background: [colors.settings_list]}">
                            <div :id="'c'+index" class="accordion-collapse collapse" :style="{ color: [colors.description]}" aria-labelledby="flush-headingOne" data-bs-parent="#todayAppointmentInfo">
                                <div class="d-flex justify-content-between" v-if="value['time_from'] != value['time_to']"><p>Time:</p> <p>{{ value["time_from"] }}-{{ value["time_to"] }}</p></div>
                                <div class="d-flex justify-content-between"><p>First name:</p> <p>{{value["first_name"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Last name:</p> <p>{{value["last_name"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Mail:</p> <p>{{value["mail"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Phone:</p> <p>{{value["phone"]}}</p></div>
                                <div class="d-flex justify-content-between"><p>Date:</p> <p>{{ convertDate(value["date"]) }}</p></div>
                                <div class="d-flex justify-content-left"><p>Products:</p></div>
                                <div class="d-flex justify-content-left" v-for="(item, index) in value['items'].substring(1, value['items'].length-1).split(',')"><p>{{item.substring(1, item.length-1)}}</p></div>
                                <div class=" d-flex justify-content-end">
                                    <a type="button" class="btn ml-1 my-auto" @click="selected='cancel_appointment'; approved_key=key; selected_mail=value['mail']" :style="{ background: [colors.danger], color: [colors.danger_button_text]}">Cancel</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </label>
        </ul>
        <div class="d-flex justify-content-center" v-else>
            <h4 :style="{ color: [colors.title]}">No appointments today..</h4>
        </div>
    
        <div class="modal-footer">
            <button type="button" class="btn" @click="onReturn(false)" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
        </div>
    </div>
    
    <div v-if="selected == 'cancel_appointment'" class="justify-content-center">
        <textarea class="form-control" v-model="cancel_mail" rows="3" placeholder="Content gets send to their email if you write a message"></textarea>
        <div class="d-flex justify-content-end my-2">
            <label class="justify-content-center mr-1 my-auto" :style="{ color: [colors.danger_text]}">Delete appointment? </label>
            <button type="button" class="btn mx-1 my-auto" @click="onReturn()" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
            <button type="button" class="btn ml-1 my-auto" @click="deleteAppointment(approved_key)" :style="{ background: [colors.danger], color: [colors.danger_button]}">Delete</button>
        </div>
    </div>
    
    <div v-if="selected == 'deny_appointment'" class="justify-content-center">
        <textarea class="form-control" v-model="cancel_mail" rows="3" placeholder="Content gets send to their email if you write a message"></textarea>
        <div class="d-flex justify-content-end my-2">
            <label class="justify-content-center mr-1 my-auto" :style="{ color: [colors.danger_text]}">Deny appointment? </label>
            <button type="button" class="btn mx-1 my-auto" @click="onReturn()" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
            <button type="button" class="btn ml-1 my-auto" @click="removeAppointment(approved_key)" :style="{ background: [colors.danger], color: [colors.danger_button]}">Delete</button>
        </div>
    </div>
    
    <div v-if="selected == 'remove_available_date'" class="d-flex justify-content-end">
        <label class="justify-content-center mr-1 my-auto" :style="{ color: [colors.danger_text]}">Remove date? </label>
        <button type="button" class="btn mx-1 my-auto" @click="onReturn('available')" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
        <button type="button" class="btn ml-1 my-auto" @click="removeAvailableDates()" :style="{ background: [colors.danger], color: [colors.danger_button]}">Delete</button>
    </div>
    
    `,
data: function(){
        return {
            colors: color.data,
            selected: false,
            dates: {},
            available_dates: [],
            date_today: new Date,
            approved_key: null,
            hidden_appointments: 0,


            new_date: null,
            new_time_from: null,
            new_time_to: null,
            new_time_danger: false,

            //Array of set dates to check whether the dates you try to apply is already created
            booked_dates: [],
            //Three dictionaries that contains data of orders to specific dates or requests
            booked_appointments: {},
            upcoming_appointments: {},
            today_appointments: {},

            customer_data: null,
            selected_mail: "",
            cancel_mail: "",
        }
    },
    created: async function() {
        await loadColors();
        await this.getBookedTimes();
        this.colors = color.data;
        this.date_today = this.getDateString();
        //Function to get all the approved requests to hide them in the request list
        this.getHiddenAppointments();
        if (this.user_data.username) {
            await this.getAvailableDates()
        }
    },
    methods: {
        // Reset values when clicking the "Back"/"Cancel" button and redirect to a destination if set
        onReturn(destination=false){
            this.selected = destination;
            this.approved_key = null;
            this.hidden_appointments = 0;
            this.new_date = null;
            this.new_time_from = null;
            this.new_time_to = null;
            this.new_time_danger = false;
            this.getHiddenAppointments();
        },

        // Converts the date string to an equal format as the input form
        getDateString() {
            let temp_date_today = this.date_today.getFullYear()+'-';
            if (this.date_today.getMonth()+1 < 10) {
                temp_date_today += '0'
            }
            temp_date_today += this.date_today.getMonth()+1+'-';
            if (this.date_today.getDate()+1 < 10) {
                temp_date_today += '0'
            }
            temp_date_today += this.date_today.getDate();
            return temp_date_today
        },
        //Checks if the selected time from-to is valid or else it resets the invalid time
        checkTime(){
            if (this.new_time_to < this.new_time_from) {
                this.new_time_danger = true;
                this.new_time_to = null;
            }
        },
        //Gets the selected date and if it already exists applies the times set for that day
        change_date(cur_date){
            this.selected = cur_date;
            this.new_date = cur_date;
            this.new_time_to = this.dates[cur_date].time_to;
            this.new_time_from = this.dates[cur_date].time_from;
        },
        async downloadAppointments() {
            let request = await fetch("/download_excel_sheet", {
                method: 'GET',
            });
            if (request.status === 200) {
                this.selected = 'download'
            }
        },
        // Retrieves the data for all requested appointments
        async getBookedTimes() {
            this.booked_appointments = {};
            let request = await fetch("/appointments/booked", {
                method: 'GET',
            });
            if (request.status === 200) {
                this.booked_appointments = await request.json();
                this.booked_dates = Object.keys(this.booked_appointments);
                let i = 0;
                for (let date of this.booked_dates) {
                    this.booked_dates[i] = date.split(";")[0];
                    i++;
                }
            }
        },
        // Retrieves all available booking dates
        getAvailableDates: async function(){
            let request = await fetch("/appointments", {
                method: 'GET',
            });
            if (request.status === 200) {
                let response = await request.json();
                this.dates = response;
                this.available_dates = Object.keys(response);
                await this.removeOutdatedDates();
                await this.removeOutdatedRequests();
                }
        },
        // Retrieves all upcoming appointments from the database (For all days past the day today)
        getUpcomingAppointments: async function(){
            let request = await fetch("/appointments/approved/upcoming", {
                method: 'GET',
            });
            if (request.status === 200) {
                this.upcoming_appointments = await request.json();
                await this.removeOutdatedDates();
                await this.removeOutdatedRequests();
                }
        },
        // Retrieves all appointments that takes place today
        getTodayAppointments: async function(){
            let request = await fetch("/appointments/approved/today", {
                method: 'GET',
            });
            if (request.status === 200) {
                this.today_appointments = await request.json();
                await this.removeOutdatedDates();
                await this.removeOutdatedRequests();
                }
        },
        // Makes a date and time available to book appointments
        addAvailableTimes: async function() {
            let request = await fetch("/appointments", {
                method: 'POST',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'date': this.new_date,
                    'time_from': this.new_time_from,
                    'time_to': this.new_time_to,
                })
            });
            if (request.status === 200) {
                showMessage("Date successfully added");
                this.getAvailableDates();
            } else if (request.status === 403) {
                showMessage('Date already exist', false)
            }
        },
        // Will update the data within available date
        updateAvailableDates: async function() {
            let request = await fetch("/appointments", {
                method: 'PUT',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'date': this.new_date,
                    'time_from': this.new_time_from,
                    'time_to': this.new_time_to,
                })
            });
            if (request.status === 200) {
                showMessage("Date successfully updated");
                this.getAvailableDates();
            } else if (request.status === 403) {
                showMessage('Something went wrong', false)
            }
        },
        // Removes an available date using a date as a key
        removeAvailableDates: async function() {
            let request = await fetch("/appointments/date/"+this.new_date, {
                method: 'DELETE',
            });
            if (request.status === 200) {
                showMessage("Date successfully removed..");
                await this.getAvailableDates();
                this.onReturn('available')
            } else if (request.status === 403) {
                showMessage('Something went wrong', false)
            }
        },
        // Approve requested appointment - Marks it with "approved" in its dictionary to hide it from the request tab
        // and inserts it into a database with all its necessary information
        approveAppointment: async function() {
            let request = await fetch("/appointments/approved", {
                method: 'POST',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'key': this.approved_key,
                })
            });
            if (request.status === 200) {
                showMessage("Appointment approved!");
                await this.getAvailableDates();
                await this.getBookedTimes();
                this.getHiddenAppointments();
                await this.sendApproveMail();
                this.onReturn()
            }

        },
        // Will request a deletion of a requested booking
        removeAppointment: async function(key) {
             let request = await fetch("/appointments/booked", {
                method: 'DELETE',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'key': key
                })
            });
            if (request.status === 200) {
                let card_id = this.booked_appointments[key]["gift_card_id"];
                let card_value_remaining = this.booked_appointments[key]["gift_card_rest"];
                let card_value_spend = this.booked_appointments[key]["gift_card_spend"];
                if (card_id) {
                    await updateGiftCardValue(card_id, card_value_remaining + card_value_spend);
                }
                showMessage("Appointment removed..", false);
                await this.getAvailableDates();
                await this.getBookedTimes();
                await this.sendCancelMail();
                this.onReturn()
            }
        },
        // deletes an appointment from the database
        deleteAppointment: async function(key) {
            let request = await fetch("/appointments/booked/" + key, {
                method: 'GET',
            });
            if (request.status === 200) {
                let response = await request.json();
                let code = response["gift_card"];
                if (!code) {
                    code = "empty"
                }
                let request2 = await fetch("/gift_card/refund/" + code, {
                    method: 'PUT',
                    headers: {"Content-Type": "application/json"},
                    body: JSON.stringify({
                        'gift_card_spend': response["gift_card_spend"],
                    })
                });
                if (request2.status === 200) {
                    let request3 = await fetch("/appointments/booked/" + key, {
                        method: 'DELETE',
                    });
                    if (request3.status === 200) {
                        key = response["date"] + ";" + response["time_from"] + ";" + response["time_to"];
                        await this.removeAppointment(key);
                        showMessage("Appointment canceled..", false);
                        await this.getAvailableDates();
                        await this.getBookedTimes();
                        await this.sendCancelMail();
                        this.onReturn()
                    }
                }
            }
        },
        // Counts how many appointments that are approved. Uses this for calculating if request list is "empty"
        getHiddenAppointments() {
            this.hidden_appointments = 0;
            for (let [_, value] of Object.entries(this.booked_appointments)) {
                if (value["approved"]) {
                    this.hidden_appointments += 1
                }
            }
        },
        // Removes any available date that has a date set to the day today or prior - this to make customers not having
        // the option to set an order to a date in the past
        removeOutdatedDates: async function() {
            let request = await fetch("/appointments/date/outdated", {
                method: 'DELETE',
            });
        },
        // Removes any outdated requests that has a date set earlier than the day today
        removeOutdatedRequests: async function() {
            let request = await fetch("/appointments/booked/outdated", {
                method: 'DELETE',
            });
        },
        sendCancelMail: async function() {
            if (this.cancel_mail) {
                let body = this.cancel_mail;
                body += "\n\n";
                body += "Lurer du på noe? Kontakt oss:\n";
                body += "Mobil: " + contact.data.phone + "\n";
                body += "Email: " + contact.data.email + "\n";
                body += "\n\n - DobbelVstudio";
                await sendMail("Kansellert ordre", body, this.selected_mail)
            }
        },
        sendApproveMail: async function() {
            let date = new Date(this.customer_data[1].split(";")[0]).toLocaleString('no-NO', {weekday: 'long', year: 'numeric', month: 'long', day: 'numeric'});
            let body = "";
            body += "Hei, " + this.customer_data[0]["first_name"] + "!\n\n";
            body += "Timen din den " + date + " kl" + this.customer_data[0]["time_from"] + "-" +
                    this.customer_data[0]["time_to"] + " er registrert! \n\nAvbestilling av time må skje 24 timer i forveien.\n\n";
            body += "Ordre: \n";
            for (let [_, item] of Object.entries(this.customer_data[0]['items'])) {
                body += item.name + " x" + item.quantity +"\n"
            }
            if (this.customer_data[0]['final_value'] || this.customer_data[0]['gift_card_spend']) {
                body += "\nÅ betale:" + this.customer_data[0]['final_value'] + "kr\n";
            } else if (!this.customer_data[0]['gift_card_spend']) {
                body += "\nÅ betale:" + this.customer_data[0]["cart_value"] + "kr\n";
            } else {
                body += "\nÅ betale:" + 0 + "kr\n";
            }
            body += "\n\n";
            body += "Lurer du på noe? Kontakt oss på:\n";
            body += "Mobil: " + contact.data.phone + "\n";
            body += "Email: " + contact.data.email + "\n";
            body += "\n\n - DobbelVstudio";
            await sendMail("Bekreftet bestilling", body, this.selected_mail)
        },
        convertDate(date) {
            return new Date(date).toLocaleString('no-NO', {weekday: 'long', year: 'numeric', month: 'long', day: 'numeric'})
        }
    },
    computed: {
        user_data: function() {
            return user.data
        }
    }

};