const productLinkC = {
    props: [],
    template: `
<header>
    <main-header></main-header>
</header>
<body class="d-flex justify-content-center" :style="{ background: [colors.body]}">
    <item></item>
</body>
<footer>
    <main-footer></main-footer>
</footer>
    `,
data: function(){
        return {
            colors: color.data,
        }
    },
    created: async function() {
        await loadColors();
        this.colors = color.data;
    },
    mounted: async function() {
        let item_id = (this.$route.params.pid);
        await getProducts(item_id);
        this.writeItemData(item_id)
    },
    methods: {
        writeItemData(item_id) {
            item_data.data.item_id = item_id;
            item_data.data.img_name = this.products.items[item_id].img_name;
            item_data.data.title = this.products.items[item_id].product_name;
            item_data.data.description = this.products.items[item_id].product_description;
            item_data.data.is_item = this.products.items[item_id].is_item;
            item_data.data.price = this.products.items[item_id].price;
            item_data.data.duration = this.products.items[item_id].duration;
            item_data.data.discount = this.products.items[item_id].discount;
        },
    },
    computed:{
        products: function(){
            return product.data
        },
    },

};