const updateCheckoutC = {
    props: [],
    template: `
<div id="checkoutInfo">
<form method = "POST" enctype = "multipart/form-data">
    <div class="form-group">
        <label :style="{ color: [colors.description]}">Checkout message</label>
        <textarea class="form-control" v-model="checkout_data.checkout_message" rows="3" placeholder="Cancellation of appointment must happen withing 48 hours of appointment"></textarea>
    </div>
    <div class="form-group">
        <label :style="{ color: [colors.description]}">Shipping available</label>
        <input class="form-check-input mx-1" type="checkbox" :value="checkout_data.shipping_available" v-model="checkout_data.shipping_available">
    </div>
    <div class="form-group">
        <label :style="{ color: [colors.description]}">Shipping message</label>
        <textarea class="form-control" v-model="checkout_data.shipping_message" rows="3" placeholder="Shipping typically takes 2-5 workdays until received"></textarea>
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description]}">Shipping price</label>
        <input class="form-control" v-model="checkout_data.shipping_price" type="number">
    </div> 
</form>

 
<div class="modal-footer">
    <button type="button" class="btn" @click="update()" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}">Save</button>
</div>
</div>

    `,
    // Contains all information displayed on the checkout
data: function(){
        return {
            colors: color.data,
            checkout_data: checkout_info.data, //Load data in dataStore
        }
    },
    created: async function(){
        await loadColors();
        this.colors = color.data;
        await getCheckoutInfo();
        this.checkout_data = checkout_info.data;
    },
methods: {
    update: async function() {
        if (isUser()) {
            let request = await fetch("/checkout", {
                method: 'PUT',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'checkout_message': this.checkout_data.checkout_message,
                    'shipping_available': this.checkout_data.shipping_available,
                    'shipping_message': this.checkout_data.shipping_message,
                    'shipping_price': this.checkout_data.shipping_price,
                })
            });
            if (request.status === 200) {
                showMessage("Information updated");
                $('#updateCheckoutModal').modal('hide');
                $('#editAppearanceModal').modal('show');
            }
        }
        },
    },
};