const updateHeaderC = {
    props: [],
    template: `
<div id="uploadHeader" class="">
<form method = "POST" enctype = "multipart/form-data">
    <div class="custom-file form-group">
        <label class="form-label" for="customFile" :style="{ color: [colors.description]}">Image</label>
        <input type="file" class="form-control" id="headerFile" name="file" @change="onFileChange" />
        <p :style="{ color: [colors.danger_text]}" v-if="image_danger && !image">Image is required</p>
        <small class="form-text text-muted" :style="{ color: [colors.description]}">Max: 50x300</small>
    </div>
</form>
<div class="col" v-if="image">
    <div class="col mb-2">
      <nav :style="{ background: [colors.header]}" class="navbar navbar-expand navbar-light sticky lg-top top-0 p-0 col" style="z-index: 1000" >
      <div class="container-fluid">
        <div class="navbar-brand col-auto">
        <a style="max-height: 50px; max-width: 300px" href="/"><img :src="image" style="max-height: 50px; max-width: 300px"></a>
        </div>

          <ul  class="navbar-nav me-auto mb-2 mb-lg-0"></ul>
            <a href="#" class="nav-link" :style="{ color: [colors.link_text]}">
              Cart
            </a>   
            <div>
            <a href="#" class="nav-link" :style="{ color: [colors.link_text]}">
              Login
            </a>
            </div>
        </div>
    </nav>
    </div>
</div>
<div class="modal-footer">
    <button type="button" class="btn" @click="upload()" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}">Change</button>
</div>
</div>
<!--<img :src="image" />-->

    `,
    data: function () {
        return {
            colors: color.data,
            image: "",
            image_danger: false,
        }
    },
    created: async function() {
        await loadColors();
        this.colors = color.data;
    },
    methods: {
        // !Taken from stack! Creates image in form of Base64 string
        onFileChange(e) {
              var files = e.target.files || e.dataTransfer.files;
              if (!files.length)
                return;
              this.createImage(files[0]);
            },
            createImage(file) {
              var image = new Image();
              var reader = new FileReader();
              var vm = this;

              reader.onload = (e) => {
                vm.image = e.target.result;
              };
              reader.readAsDataURL(file);
            },
        // Uploads image
        upload: async function () {
            if (this.image && isUser()) {
                let request = await fetch("/header", {
                    method: 'POST',
                    headers: {"Content-Type": "application/json"},
                    body: JSON.stringify({
                        'img': this.image
                    })
                });
                if (request.status === 200) {
                    showMessage("Header logo updated!");
                    this.image = "";
                    this.image_danger = true;
                    $('#updateHeaderModal').modal('hide');
                    $('#editAppearanceModal').modal('show');
                }
            } else {
                this.image_danger = true;
            }
        },
    },
};