const updateInfoC = {
    props: [],
    template: `
<div id="editContactInfo">
<form method = "POST" enctype = "multipart/form-data">
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Name</label>
        <input class="form-control" v-model="contact.name" placeholder="Enter contact name">
    </div>
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Email</label>
        <input class="form-control" type="email" v-model="contact.email" placeholder="Enter contact email">
    </div>
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Mobile</label>
        <input class="form-control" v-model="contact.phone" placeholder="Enter mobile/phone number">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Address</label>
        <input class="form-control" v-model="contact.address" placeholder="Enter address">
    </div>
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Address url</label>
        <input class="form-control" v-model="contact.address_link" placeholder="Enter address url">
    </div>
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Comment</label>
        <input class="form-control" v-model="contact.comment" placeholder="ex: Replies within 2 working days">
    </div> 
    <hr/>
    <div class="my-4">
        <a :style="{ color: [colors.description] }" @click="openUrl('https://icons.getbootstrap.com/')">
            Icons
            <i class="bi bi-arrow-up-right-square"></i>
        </a>
    </div>
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 1</label>
        <input class="form-control" v-model="contact.platform_1" placeholder="Enter platform 1">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 1 url</label>
        <input class="form-control" v-model="contact.platform_1_url" placeholder="Enter platform 1 url">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 1 logo</label>
        <input class="form-control" v-model="contact.platform_1_logo" placeholder="Enter platform 1 logo: 'bi bi-instagram'">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 2</label>
        <input class="form-control" v-model="contact.platform_2" placeholder="Enter platform 2">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 2 url</label>
        <input class="form-control" v-model="contact.platform_2_url" placeholder="Enter platform 2 url">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 2 logo</label>
        <input class="form-control" v-model="contact.platform_2_logo" placeholder="Enter platform 2 logo">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 3</label>
        <input class="form-control" v-model="contact.platform_3" placeholder="Enter platform 3">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 3 url</label>
        <input class="form-control" v-model="contact.platform_3_url" placeholder="Enter platform 3 url">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 3 logo</label>
        <input class="form-control" v-model="contact.platform_3_logo" placeholder="Enter platform 3 logo">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 4</label>
        <input class="form-control" v-model="contact.platform_4" placeholder="Enter platform 4">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 4 url</label>
        <input class="form-control" v-model="contact.platform_4_url" placeholder="Enter platform 4 url">
    </div> 
    <div class="form-group">
        <label :style="{ color: [colors.description] }">Platform 4 logo</label>
        <input class="form-control" v-model="contact.platform_4_logo" placeholder="Enter platform 4 logo">
    </div> 
</form>

 
<div class="modal-footer">
    <button type="button" class="btn" @click="update()" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}">Save</button>
</div>
</div>

    `,
    // Contains all contact information that in stored in the footer
data: function(){
        return {
            colors: color.data,
            contact: contact.data,
        }
    },
    created: async function(){
        await loadColors();
        this.colors = color.data;
        await getContact();
        this.contact = contact.data;
    },
methods: {
    update: async function() {
        if (isUser()) {
            let request = await fetch("/contact", {
                method: 'PUT',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'name': this.contact.name,
                    'email': this.contact.email,
                    'phone': this.contact.phone,
                    'address': this.contact.address,
                    'address_link': this.contact.address_link,
                    'platform_1': this.contact.platform_1,
                    'platform_1_url': this.contact.platform_1_url,
                    'platform_1_logo': this.contact.platform_1_logo,
                    'platform_2': this.contact.platform_2,
                    'platform_2_url': this.contact.platform_2_url,
                    'platform_2_logo': this.contact.platform_2_logo,
                    'platform_3': this.contact.platform_3,
                    'platform_3_url': this.contact.platform_3_url,
                    'platform_3_logo': this.contact.platform_3_logo,
                    'platform_4': this.contact.platform_4,
                    'platform_4_url': this.contact.platform_4_url,
                    'platform_4_logo': this.contact.platform_4_logo,
                    'comment': this.contact.comment,
                })
            });
            if (request.status === 200) {
                showMessage("Information updated!");
                $('#updateInfoModal').modal('hide');
                $('#editAppearanceModal').modal('show');
            }
        }
    },
    openUrl(url){
            window.open(url, 'popup');
        }
    },
};