const updatePaletteC = {
    props: [],
    template: `
<div id="customizePalette" class="">

<div class="input-group mb-3 my-auto d-flex justify-content-between">
    <div class="my-2">
        <h5 :style="{ color: [title]}">Header: </h5>
        <input class="m-1" type="color" v-model="header" @change="update()">
        <input class="m-1" type="color" v-model="link_text" @change="update()">
    </div><br/>
    <div class="col-12">
      <nav :style="{ background: [header]}" class="navbar navbar-expand navbar-light sticky lg-top top-0 p-0 col" style="z-index: 1000" >
      <div class="container-fluid" style="max-width: 1024px">
        <div class="navbar-brand col-auto">
        <a style="max-height: 50px; max-width: 300px" href="/"><img :src="image" style="max-height: 50px; max-width: 300px"></a>
        </div>

          <ul  class="navbar-nav me-auto mb-2 mb-lg-0"></ul>
            <a href="#" class="nav-link" :style="{ color: [link_text]}">
              Cart
              <i class="fas fa-print me-3 bi bi-bag" :style="{ color: [link_text]}"></i> 
            </a>   
            <div>
            <a href="#" class="nav-link" :style="{ color: [link_text]}">
              Login
            </a>
            </div>
        </div>
    </nav>
    </div>
</div>
<hr>
<div>
    <div class="input-group mb-3 my-auto d-flex justify-content-between">
    <div class="my-2">
        <h5 :style="{ color: [title]}">Body: </h5>
        <input class="" type="color" v-model="body" @change="update()">
    </div><br/>
    <div class="col-12">
      <nav :style="{ background: [body]}" class="navbar navbar-expand navbar-light sticky lg-top top-0 p-0 col" style="z-index: 1000" >
      <div class="container-fluid" style="height: 50px">
           
        </div>
    </nav>
    </div>
    </div>
</div>
<hr>
<div>
    <div class="input-group mb-3 my-auto d-flex justify-content-between">
    <div class="my-2">
        <h5 :style="{ color: [title]}">Footer: </h5>
        <input class="" type="color" v-model="footer" @change="update()">
        <input class="m-1" type="color" v-model="title" @change="update()">
        <input class="m-1" type="color" v-model="description" @change="update()">
    </div><br/>
    <div class="col-12">
    <nav :style="{ background: [footer]}" class="navbar navbar-expand navbar-light sticky lg-top top-0 p-0 col" style="z-index: 1000" >
      <div class="container-fluid px-4 d-flex justify-content-left p-2" style="max-width: 1024px">
        <div class="pt-2 col-md-4 col-lg-3 col-xl-3 mb-md-0">
          <h6 class="text-uppercase fw-bold mb-4" :style="{ color: [title] }">
            Contact
          </h6>
          <div class="d-flex">
            <i class="fas fa-print me-3 bi bi-journal"></i>
            <p :style="{ color: [description] }">Sample Name</p>
          </div>
        </div>
      </div>
    </nav>
    </div>
    </div>
</div>
<hr>
<div>
    <div class="input-group mb-3 my-auto d-flex justify-content-between">
    <div class="my-2">
        <h5 :style="{ color: [title]}">Card: </h5>
        <input class="m-1" type="color" v-model="inner_body" @change="update()">
        <input class="m-1" type="color" v-model="inner_footer" @change="update()">
        <input class="m-1" type="color" v-model="cart_button" @change="update()">
        <input class="m-1" type="color" v-model="cart_button_text" @change="update()">
    </div><br/>
    
</div>
</div>
<div class="col p-2" :style="{ background: [body] }">
    <div class="col py-5 mx-auto">
      <div class="col-md-9 mb-4 mx-auto">
        <div class="card h-100">
          <a href="#"><img class="card-img-top" src="/static/images/stock/sample.jpg" style="max-height: 500px; max-width: 400px" alt=""></a>
          <div class="card-body" :style="{ background: [inner_body]}">
            <h4>
              <a :style="{ color: [title]}">Title</a>
            </h4>
            <p class="card-text" :style="{ color: [description]}">Description</p>
            <p class="d-flex justify-content-end text-muted"><small>Tid: 8min</small></p>
        </div>
          <div class="card-footer d-flex justify-content-between" :style="{ background: [inner_footer]}">
              <div class="d-flex">
                <p class="my-auto mx-2" :style="{ color: [description]}"><del>kr49,-</del></p>
                <p class="my-auto mx-2" :style="{ color: [title]}">Kr39,-</p>
              </div>
              <button type="button" class="btn nav-link" :style="{ background: [cart_button], color: [cart_button_text]}">
                  Add to cart
              </button>
          </div>
      </div>
    </div>
</div>
</div>
<hr>
<div>
    <div class="input-group mb-3 my-auto d-flex justify-content-between">
    <div class="my-2">
        <h5 :style="{ color: [title]}">Dropdown: </h5>
        <input class="m-1" type="color" v-model="inner_header" @change="update()">
        <input class="m-1" type="color" v-model="settings_list" @change="update()">
        <input class="m-1" type="color" v-model="settings_text" @change="update()">
        <input class="m-1" type="color" v-model="button_accept" @change="update()">
        <input class="m-1" type="color" v-model="button_accept_text" @change="update()">
        <input class="m-1" type="color" v-model="button_cancel" @change="update()">
        <input class="m-1" type="color" v-model="button_cancel_text" @change="update()">
    </div><br/>
    <div class="col p-2 border-3" :style="{ background: [body] }"> <!-- filter: ['brightness(50%)'] -->
    <div class="col-11 py-4 m-auto" > <br/>
    <div class="modal-header" :style="{ background: [inner_header]}" >
        <h4 class="modal-title my-auto" :style="{ color: [title]}">Title</h4>
      </div>
      <div class="modal-body" :style="{ background: [inner_body]}">
<div id="settings" class="">
    <ul class="list-group">
    <label class="list-group-item" :style="{ background: [settings_list]}">
        <a href="#" class="nav-link" :style="{ color: [settings_text]}">
          Sample 1
        </a>
    </label>
    <label class="list-group-item" :style="{ background: [settings_list]}">
        <a href="#" class="nav-link" :style="{ color: [settings_text]}">
          Sample 2
        </a>
    </label>
    </ul>
    <div class="modal-footer" :style="{ background: [inner_footer]}">
    <button type="button" class="btn" :style="{ background: [button_cancel], color: [button_cancel_text]}">Cancel</button>
    <button type="button" class="btn" :style="{ background: [button_accept], color: [button_accept_text]}">Save</button>
    </div>
</div>
</div>
</div>
</div>
</div>
</div>
<hr>
<div>
    <div class="input-group mb-3 my-auto d-flex justify-content-between">
    <div class="my-2">
        <h5 :style="{ color: [title]}">Other: </h5>
        <input class="m-1" type="color" v-model="success" @change="update()">
        <input class="m-1" type="color" v-model="success_text" @change="update()">
        <input class="m-1" type="color" v-model="danger" @change="update()">
        <input class="m-1" type="color" v-model="danger_button_text" @change="update()">
    </div><br/>
    <div class="col-11" > 
        <a class="list-group-item list-group-item-success my-3" href="#" :style="{ background: [success], color: [success_text]}">Success</a>
    </div>
    <div class="col-11">
        <a class="list-group-item list-group-item-success my-3" href="#" :style="{ background: [danger], color: [danger_button_text]}">Danger</a>
    </div>
    <div class="col-11">
    <label class="list-group-item my-3" :style="{ background: [settings_list]}">
        <a href="#" class="nav-link" :style="{ color: [danger]}">
          Danger
        </a>
    </label>
    </div>
    </div>
</div>

</div>
<div class="modal-footer">
    <button type="button" class="btn" @click="resetColor()"  :style="{ background: [button_cancel], color: [button_cancel_text]}">Restore default</button>
    <button type="button" class="btn" @click="updateColor()"  :style="{ background: [button_accept], color: [button_accept_text]}">Save</button>
</div>
    `,
    // Contains all colors used on the website
    // Has a preview for each color in an example
data: function(){
        return {
            header: "",
            inner_header: "",
            body: "",
            inner_body: "",
            footer: "",
            title: "",
            description: "",
            inner_footer: "",
            settings_list: "",
            settings_text: "",
            cart_button: "",
            cart_button_text: "",
            button_accept: "",
            button_accept_text: "",
            button_cancel: "",
            button_cancel_text: "",
            success: "",
            success_text: "",
            danger: "",
            danger_button_text: "",
            danger_text: "",
            link_text: "",
            image: "",
            card: "",
        }
    },
    created: async function() {
        let request = await fetch("/header", {
            method: 'GET',
        });
        if (request.status === 200) {
            this.image = await request.json();
        }
        this.header = color.data.header;
        this.inner_header = color.data.inner_header;
        this.body = color.data.body;
        this.inner_body = color.data.inner_body;
        this.footer = color.data.footer;
        this.title = color.data.title;
        this.description = color.data.description;
        this.inner_footer = color.data.inner_footer;
        this.settings_list = color.data.settings_list;
        this.settings_text = color.data.settings_text;
        this.cart_button = color.data.cart_button;
        this.cart_button_text = color.data.cart_button_text;
        this.button_accept = color.data.button_accept;
        this.button_accept_text = color.data.button_accept_text;
        this.button_cancel = color.data.button_cancel;
        this.button_cancel_text = color.data.button_cancel_text;
        this.success = color.data.success;
        this.success_text = color.data.success_text;
        this.danger = color.data.danger;
        this.danger_button_text = color.data.danger_button_text;
        this.link_text = color.data.link_text;
},

methods: {
        //Updates the JSON file that contains colors
        updateColor: async function() {
            if (isUser()) {
                let request = await fetch("/colors", {
                    method: 'PUT',
                    headers: {"Content-Type": "application/json"},
                    body: JSON.stringify({
                        'header': this.header,
                        'inner_header': this.inner_header,
                        'body': this.body,
                        'inner_body': this.inner_body,
                        'footer': this.footer,
                        'title': this.title,
                        'description' : this.description,
                        'inner_footer': this.inner_footer,
                        'settings_list': this.settings_list,
                        'settings_text': this.settings_text,
                        'cart_button': this.cart_button,
                        'cart_button_text': this.cart_button_text,
                        'button_accept': this.button_accept,
                        'button_accept_text': this.button_accept_text,
                        'button_cancel': this.button_cancel,
                        'button_cancel_text': this.button_cancel_text,
                        'danger': this.danger,
                        'danger_button_text': this.danger_button_text,
                        'success': this.success,
                        'success_text': this.success_text,
                        'link_text': this.link_text,
                    })
                });
                if (request.status === 200) {
                    window.location.reload();
                }
            }
        },
    resetColor: async function() {
            let request = await fetch("/colors/reset", {
                method: 'PUT',
            });
            if (request.status === 200) {
                window.location.reload();
            }
    },
    update(){
        color.data.header = this.header;
        color.data.inner_header = this.inner_header;
        color.data.body = this.body;
        color.data.inner_body = this.inner_body;
        color.data.footer = this.footer;
        color.data.inner_footer = this.inner_footer;
        color.data.settings_list = this.settings_list;
        color.data.settings_text = this.settings_text;
        color.data.cart_button = this.cart_button;
        color.data.cart_button_text = this.cart_button_text;
        color.data.button_accept = this.button_accept;
        color.data.button_accept_text = this.button_accept_text;
        color.data.button_cancel = this.button_cancel;
        color.data.button_cancel_text = this.button_cancel_text;
        color.data.success = this.success;
        color.data.success_text = this.success_text;
        color.data.danger = this.danger;
        color.data.danger_button_text = this.danger_button_text;
        color.data.danger_text = this.danger_text;
        color.data.link_text = this.link_text;
    },
},


};