const removeCodesC = {
    props: [],
    template: `
<div id="selectCards" v-if="!selected && !cur_card">
    <ul class="list-group" @click="sortCards()">
    <label class="list-group-item" :style="{ background: [colors.settings_list]}" >
        <a href="#" class="nav-link" @click="select('gift_cards')" :style="{color: [colors.settings_text]}">
          Gift cards
        </a>
    </label>
    <label class="list-group-item" :style="{ background: [colors.settings_list]}" >
        <a href="#" class="nav-link" @click="select('discount_codes')" :style="{color: [colors.settings_text]}">
          Discount codes
        </a>
    </label>
    </ul>
</div>
<div v-if="selected == 'gift_cards' && !cur_card">
    <ul class="list-group">
    <label class="list-group-item" v-for="card in gift_cards" :style="{ background: [colors.settings_list]}" >
        <a href="#" class="nav-link" :style="{color: [colors.settings_text]}" @click="getCard(card.card_id)">
          {{ card.card_code }}
        </a>
    </label>
    </ul>
</div>
<div v-if="selected == 'discount_codes' && !cur_card">
    <ul class="list-group">
    <label class="list-group-item" v-for="card in discount_codes" :style="{ background: [colors.settings_list]}" >
        <a href="#" class="nav-link" :style="{color: [colors.settings_text]}" @click="getCard(card.card_id)">
          {{ card.card_code }}
        </a>
    </label>
    </ul>
</div>
<div id="addProduct" v-if="selected && cur_card">
        <form method = "POST" enctype = "multipart/form-data">
            <div class="form-group">
                <label :style="{ color: [colors.description]}">Card code</label>
                <div class="row m-0">
                    <h4 :style="{ color: [colors.title]}">{{card_code}}</h4>
                </div>
            </div>
            <div class="form-group" v-if="card_type == 'discount_code'">
                <label :style="{ color: [colors.description]}">Discount type</label>
                <div class="row m-0">
                    <h4 :style="{ color: [colors.title]}">{{discount_type}}</h4>
                </div>
            </div>
            <div class="form-group" v-if="card_type == 'discount_code'">
                <label :style="{ color: [colors.description]}">Category</label>
                <div class="row m-0">
                    <h4 :style="{ color: [colors.title]}">{{category}}</h4>
                </div>
            </div>
            <div class="form-group" v-if="card_type == 'discount_code'">
                <label :style="{ color: [colors.description]}">Discount</label>
                <div class="row m-0">
                    <h4 :style="{ color: [colors.title]}">{{discount}}%</h4>
                </div>
            </div>
            <div class="form-group" v-if="card_type == 'gift_card'">
                <label :style="{ color: [colors.description]}">Value</label>
                <div class="row m-0">
                    <h4 :style="{ color: [colors.title]}">kr{{value}},-</h4>
                </div>
            </div>
            <div class="form-group">
                <label :style="{ color: [colors.description]}">Expiration</label>
                <div class="row m-0">
                    <h4 :style="{ color: [colors.title]}">{{expiration}}</h4>
                </div>
            </div>
        </form>
    </div>
<div class="modal-footer" v-if="selected">
    <button type="button" class="btn" @click="onReturn()" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">
        Cancel
    </button>
    <button v-if="cur_card" type="button" class="btn" @click="remove()"  :style="{ background: [colors.danger], color: [colors.danger_button_text]}">Delete</button>
</div>
    `,
    //
data: function(){
        return {
            selected: "",
            colors: color.data,
            gift_cards: [],
            discount_codes: [],
            cur_card: null,
            card_id: 0,
            card_code: "",
            card_type: "",
            discount_type: "all",
            category: "all",
            discount: 0,
            value: 0,
            expiration: null
        }
    },
created: async function(){
        await loadColors();
        this.colors = color.data;
        },
methods: {
        sortCards(){
            if (this.gift_cards.length === 0 && this.discount_codes.length === 0) {
                for (const [key, card] of Object.entries(this.cards)) {
                    if (card.card_type === 'gift_card') {
                        this.gift_cards.push(card)
                    } else {
                        this.discount_codes.push(card)
                    }
                }
            }
            },
    select(option){
            this.selected = option;
    },
    // Retrieve card selected
    getCard: async function(card_id){
                let request = await fetch("/gift_card/id/"+card_id, {
                method: 'GET',
                });
                if (request.status === 200) {
                    let response = await request.json();
                    this.cur_card = response[card_id];
                    this.getCardData();
                }
    },
    getCardData(){
            this.card_code = this.cur_card['card_code'];
            this.category = this.cur_card['card_category'];
            this.discount = this.cur_card['card_discount'];
            this.value = this.cur_card['card_value'];
            this.expiration = this.cur_card['expiration_date'];
            this.discount_type = this.cur_card['discount_type'];
            this.card_type = this.cur_card['card_type'];
            this.card_id = this.cur_card['card_id'];
    },
    // Delete selected card from database
    remove: async function(){
            if (isUser()) {
                let request = await fetch("/gift_card/id/"+this.card_id, {
                    method: 'DELETE',
                });
                if (request.status === 200) {
                    await getCards();
                    this.sortCards();
                    this.gift_cards = [];
                    this.discount_codes = [];
                    this.onReturn();
                    showMessage("Promo code removed..");
                    await getCards()
                }
            }
            },
            onReturn(){
                    this.selected = "";
                    this.cur_card = null;
                    this.discount_type = "";
                    this.card_type = "";
            }
    },
    computed: {
        cards: function() {
            return cards.data.cards
        }
    }

};