const addProductC = {
    props: [],
    template: `
<div id="addProducts" >

    <div id="addProduct" v-if="!is_category">
    <form method = "POST" enctype = "multipart/form-data">
        <div class="form-group">
            <label :style="{ color: [colors.description]}">Title</label>
            <input class="form-control" id="new-product-title" v-model="title" placeholder="Enter product title">
            <p :style="{ color: [colors.danger_text]}" v-if="title_danger && title.length <= 0">Title is required</p>
        </div>
        <div class="custom-file form-group">
            <label class="form-label" for="customFile" :style="{ color: [colors.description]}">Image</label>
            <input type="file" class="form-control" id="customFile" name="file" @change="onFileChange" />
            <p :style="{ color: [colors.danger_text]}" v-if="image_danger && image.length <= 0">Image is required</p>
            <small class="form-text" :style="{ color: [colors.description]}">Preferably 400x500</small>
        </div>
        <div class="invalid-feedback">Invalid file</div>
        <div class="form-group">
            <label :style="{ color: [colors.description]}">Description</label>
            <textarea class="form-control" id="product-description" v-model="description" rows="3" placeholder="Enter product description"></textarea>
        </div>
        <div class="form-group">
            <label :style="{ color: [colors.description]}">Category</label>
            <div class="row m-0">
            <select class="form-control m-0 col-9" v-model="category" >
                <option v-for="(option, index) in categories" :value="option">{{option}}</option>
            </select>
            <a class="col-1 mx-auto p-0" @click="select_category">
                <div class="btn" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Edit</div>
            </a>
            </div>
        </div>
        <div class="form-group">
            <label :style="{ color: [colors.description]}">Price</label>
            <input class="form-control" type="number" v-model="price" id="new-product-price" placeholder="kr">
        </div>
        <div class="form-group" v-if="!item">
            <label :style="{ color: [colors.description]}">Duration</label>
            <input class="form-control" type="number" id="new-product-duration" v-model="duration" placeholder="min">
        </div>
        <div class="form-check form-check-inline form-group d-flex right-0">
          <label class="form-check-label" for="inlineCheckbox1" :style="{ color: [colors.description]}">Item</label>
          <input class="form-check-input mx-1" type="checkbox" id="new_item_input" value="1" v-model="item" @click="durationReset()">
        </div>
    </form>
    
        <div class="col p-2 border-3" :style="{ background: [colors.body] }">
            <div class="row my-5">
                  <div class="col-md-9 mb-4 mx-auto">
                    <div class="card h-100" :style="{ background: [colors.body]}">
                      <a href="#"><img class="card-img-top" :src="image" style="max-height: 500px; max-width: 400px" alt=""></a>
                      <div class="card-body" :style="{ background: [colors.inner_body]}">
                        <h4 class="card-title text-dark">
                          <a href="#" :style="{ color: [colors.title]}">{{ title }}</a>
                        </h4>
                        <p v-if="description.length<50" class="card-text" :style="{ color: [colors.description]}">{{ description }}</p>
                        <p v-else class="card-text" :style="{ color: [colors.description]}">{{ description.substring(0,50)+'..' }}</p>
                        <p class="d-flex justify-content-end" v-if="!item" :style="{ color: [colors.description]}"><small>Tid: {{ duration }}min</small></p>
                    </div>
                      <div class="card-footer d-flex justify-content-between" :style="{ background: [colors.inner_footer]}">
                        <p class="my-auto" :style="{ color: [colors.title]}">kr{{ price }},-</p>
                        <button type="button" class="btn nav-link" :style="{ background: [colors.cart_button], color: [colors.cart_button_text]}" >
                            Add to cart
                        </button>
                      </div>
                  </div>
                </div>
            </div>
        </div>
    <div class="modal-footer">
        <button type="button" class="btn" @click="upload()" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}">Save</button>
    </div>
    </div>
    <div id="editCategories" v-if="is_category">
        <div class="form-group">
            <label><h4>Add category</h4></label>
            <div class="row m-0">
            <input class="form-control form-control m-0 col-9" id="new-product-title" v-model="new_category" placeholder="Enter new category">
            <a class="col-1 mx-auto p-0">
                <div class="btn" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}" @click="add_category()">Add</div>
            </a>
            </div>
        </div>
        <ul class="list-group">
            <label class="list-group-item d-flex justify-content-between" v-for="(cat, index) in categories" :style="{ background: [colors.settings_list]}" >
                <a href="#" class="nav-link" :style="{color: [colors.settings_text]}">
                  {{ cat }}
                </a>
                <button type="button" class="close" aria-label="Close" @click="remove(index)">
                  <span aria-hidden="true">&times;</span>
                </button>
            </label>
        </ul>
        <div class="d-flex justify-content-end m-1 my-3">
            <button type="button" class="btn" @click="select_category()" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Back</button>
        </div>
    </div>
</div>
<!--<img :src="image" />-->

    `,
    data: function () {
        return {
            colors: color.data,
            title: "",
            description: "",
            category: categories.data.categories[0],
            is_category: false,
            new_category: "",
            price: 0,
            duration: 0,
            item: 0,
            image: "",

            title_danger: false,
            image_danger: false,
        }
    },
    created: async function(){
        await loadColors();
        this.colors = color.data;
        await getCategories();
        categories.data.categories.sort();
        this.category = categories.data.categories[0];
    },
    methods: {
        // !Taken from stackoverflow!
        // Creates a src of the image file in the Base64 format that can be read as a src in a img tag
        onFileChange(e) {
              var files = e.target.files || e.dataTransfer.files;
              if (!files.length)
                return;
              this.createImage(files[0]);
            },
            createImage(file) {
              let image = new Image();
              let reader = new FileReader();
              let vm = this;

              reader.onload = (e) => {
                vm.image = e.target.result;
              };
              reader.readAsDataURL(file);
            },

        // Uploads the product data as well at the Base64 string of the image to backend
        upload: async function () {
            if (this.image && this.title && isUser()) {
                let request = await fetch("/uploader", {
                    method: 'POST',
                    headers: {"Content-Type": "application/json"},
                    body: JSON.stringify({
                        'title': this.title, 'description': this.description, 'price': this.price,
                        'duration': this.duration, 'item': this.item, 'img': this.image,
                        'category': this.category
                    })
                });
                if (request.status === 200) {
                    await getProducts(); // If successful upload, get products to instantly show on homepage
                    this.reset();
                    this.image_danger = false;
                    this.title_danger = false;
                    showMessage("Product created!");
                    $('#addProductModal').modal('hide');
                    $('#editProductsModal').modal('show');
                }
            } else {
                    if (!this.image) {
                        this.image_danger = true;
                    }
                    if (!this.title){
                        this.title_danger = true;
                    }
                }
        },
        durationReset() {
            this.duration = 0
        },
        remove: async function(index){
            this.categories.splice(index, 1);
            await this.delete_category()
        },

        add_category: async function(){
            if (!this.categories.includes(this.new_category)){
                this.categories.push(this.new_category);
                this.categories.sort();
                this.new_category = "";
                await this.save_categories();
            }
        },
        // Saves the collection on categories into a JSON file
        save_categories: async function(){
            let request = await fetch("/categories", {
                method: 'POST',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'categories': this.categories
                })

            });
            if (request.status === 200) {
                    showMessage("Category successfully edited")
                }
        },
        // Removes a category from the JSON file
        delete_category: async function(){
            let request = await fetch("/categories", {
                method: 'DELETE',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'categories': this.categories
                })

            });
            if (request.status === 200) {
                    showMessage("Category successfully added")
                }
        },
        select_category() {
            this.is_category = !this.is_category;
        },
        reset(){
            this.title = "";
            this.description = "";
            this.is_category = false;
            this.new_category = "";
            this.price = 0;
            this.duration = 0;
            this.item = 0;
            this.image = "";
        }
    },
    computed: {
        user_data: function() {
            return user.data
        },
        categories: function() {
            return categories.data.categories
        }
    }
};

// Check if product is unique and has an image before being able to save
// Resize/limit image on upload
// add category option