const removeProductC = {
    props: [],
    template: `

<div id="selectProduct" v-if="!product_selected">
    <ul class="list-group">
    <label class="list-group-item" v-for="product in products.items" :style="{ background: [colors.settings_list]}">
        <a href="#" class="nav-link" @click="getItemData(product.product_id)" :style="{ color: [colors.settings_text]}">
          {{ product.product_name }}
        </a>
    </label>
    </ul>
</div>
<div id="removeProduct" class="" v-if="product_selected">
    <div class="col p-2 border-3" :style="{ background: [colors.body] }">
        <div class="row my-5">
              <div class="col-md-9 mb-4 mx-auto">
                <div class="card h-100" :style="{ background: [colors.body]}">
                  <a v-if="image" href="#"><img class="card-img-top" :src="image" style="max-height: 500px; max-width: 400px" alt=""></a>
                  <a v-else href="#"><img class="card-img-top" :src="'/static/images/products/'+old_image+'.jpg'" style="max-height: 500px; max-width: 400px" alt=""></a>
                  <div class="card-body" :style="{ background: [colors.main_card_color]}">
                    <h4 class="card-title text-dark">
                      <a href="#" :style="{ color: [colors.title]}">{{ title }}</a>
                    </h4>
                    <p v-if="description.length<50" class="card-text" :style="{ color: [colors.description]}">{{ description }}</p>
                    <p v-else class="card-text" :style="{ color: [colors.description]}">{{ description.substring(0,50)+'..' }}</p>
                    <p class="d-flex justify-content-end" v-if="!item" :style="{ color: [colors.description]}"><small>Tid: {{ duration }}min</small></p>
                </div>
                  <div class="card-footer d-flex justify-content-between" :style="{ background: [colors.inner_footer]}">
                    <p class="my-auto" :style="{ color: [colors.title]}">kr{{ price }},-</p>
                    <button type="button" class="btn nav-link" :style="{ background: [colors.cart_button], color: [colors.cart_button_text]}" >
                        Add to cart
                    </button>
                  </div>
              </div>
            </div>
        </div>
</div>
<div class="modal-footer">
    <button type="button" class="btn" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}" @click="onReturn()">Cancel</button>
    <button type="button" class="btn" :style="{ background: [colors.danger], color: [colors.danger_button_text]}" @click="remove()">Remove</button>
</div>
</div>
<!--<img :src="image" />-->

    `,
    data: function () {
        return {
            colors: color.data,
            products: product.data,
            product_selected: false,
            id: 0,
            title: "",
            description: "",
            price: 0,
            duration: 0,
            item: 0,
            image: "",
            old_image: "",
            final_image: "",
        }
    },
    created: async function() {
        await loadColors();
        this.body = color.data.body;
        this.colors = color.data
    },
    methods: {
        // Retrieves all products from database
        getItemData: async function(product_id) {
            let request = await fetch("/product/id/"+product_id, {
                method: 'GET',
            });
            if (request.status === 200) {
                let response = await request.json();
                this.id = response['product_id'];
                this.title = response['product_name'];
                this.description = response['product_description'];
                this.price = response['price'];
                this.duration = response['duration'];
                this.item = response['is_item'];
                this.old_image = response['img_name'];
                this.final_image = response['img_name'];
                this.product_selected = true;
            }
        },
        onReturn() {
            this.product_selected = false;
            this.id = 0;
            this.title = "";
            this.description = "";
            this.pricen = 0;
            this.duration = 0;
            this.item = 0;
            this.image = "";
            this.old_image = "";
            this.final_image = "";
        },
        // Removes product from database
        remove: async function () {
            if (isUser()) {
                let request = await fetch("/product/id/"+this.id, {
                    method: 'DELETE',
                });
                if (request.status === 200) {
                    await getProducts();
                    this.reset();
                    showMessage("Product removed..")
                }
                request = await fetch("/product/img/"+this.old_image, {
                    method: 'DELETE',
                });
                if (request.status === 200) {
                    await getProducts();
                    this.reset();
                    this.onReturn();
                    showMessage("Product removed..");
                    this.product_selected = false;
                    // $('#removeProductModal').modal('hide');
                    // $('#editProductsModal').modal('show');
                }
            }

        },
        reset(){
            this.title = "";
            this.description = "";
            this.is_category = false;
            this.new_category = "";
            this.price = 0;
            this.duration = 0;
            this.item = 0;
            this.image = "";
        }
    },

};

//Flash remove message