const addUserC = {
    props: [],
    template: `
    <form @submit.prevent>
        <label class="col" :style="{ color: [colors.description] }">Username: <input class="border-1 form-control-lg col" v-model='username' type="text" name="username" placeholder="Username"/></label><br />
        <p :style="{ color: [colors.danger_text]}" class="d-flex justify-content-center" v-if="danger_username && username.length < 5">Username requires at least 5 characters</p>
        <label class="col" :style="{ color: [colors.description] }">Password: <input class="border-1 form-control-lg col" v-model='password' type="password" name="password" placeholder="Password"></label><br />
        <p :style="{ color: [colors.danger_text]}" class="d-flex justify-content-center" v-if="danger_password && password.length < 8">Password requires at least 8 characters</p>
        <div class="mb-3">
          <div class="form-check">
            <label class="form-check-label" :style="{ color: [colors.description] }">
              Admin:
            </label>
            <input class="form-check-input mx-2" type="checkbox" v-model="role" disabled v-if="user_data.user_id != 1">
            <input class="form-check-input mx-2" type="checkbox" v-model="role" v-else>
          </div>
        </div>
        <input class="dropdown-item form-control-lg" type="submit" value="Register" @click="register()" :style="{ background: [colors.settings_list_color], color: [colors.settings_text]}">
    </form>

    `,
    data() {
        return {
            colors: color.data,
            username: '',
            password: '',
            role: '',
            danger_username: false,
            danger_password: false,
            success: false,
        }
    },
    created: async function() {
        await loadColors();
        await getUsers();
        this.colors = color.data;
    },
    methods: {
        // Add new user to the database from the given data in the form
        register: async function () {
            if (this.password.length >= 8 && this.username.length >= 5 && isUser()) {
                let request = await fetch("/register", {
                    method: 'POST',
                    headers: {"Content-Type": "application/json"},
                    body: JSON.stringify({'username': this.username, 'password': this.password, 'role': this.role}),
                });
                if (request.status === 200) {
                    showMessage("User successfully created!!");
                    this.danger_username = false;
                    this.danger_password = false;
                    await getUsers();
                    $('#addUserModal').modal('hide');
                }
            } else {
                if (this.password.length <= 8) {
                    this.danger_password = true;
                }
                if (this.username.length <= 5) {
                    this.danger_username = true;
                }
            }
        },
    },
    computed: {
        users_data: function() {
            return users.data.users
        },
        user_data: function() {
            return user.data
        }
    }

};

// Add criteria for username and password