const editUserC = {
    props: [],
    template: `
<div id="selectUser" v-if="!user_selected && user_data.role == 'admin'">
    <ul class="list-group">
    <label class="list-group-item" v-for="user in users.users" :style="{ background: [colors.settings_list]}" v-show="(user.user_id != 1 && user_data.user_id != 1) || user_data.user_id == 1">
        <a href="#" class="nav-link" @click="getUserData(user)" :style="{ color: [colors.settings_text]}">
          {{ user.user_name }}
        </a>
    </label>
    </ul>
</div>
<div id="thisUser" v-if="!user_selected && user_data.role == 'staff'" >
    <ul class="list-group">
    <label class="list-group-item" :style="{ background: [colors.settings_list]}">
        <a href="#" class="nav-link" @click="getThisUser()" :style="{ color: [colors.settings_text]}">
          {{ user_data.username }}
        </a>
    </label>
    </ul>
</div>
<div id="editUser" class="" v-if="user_selected">

<form @submit.prevent @submit="editUser()">
        <label class="col-2" :style="{ color: [colors.description] }">Username: <input class="border-1 form-control-lg" v-model='username' type="text" name="username" /></label><br />
        <p :style="{ color: [colors.danger_text]}" class="d-flex justify-content-center" v-if="danger_username && username.length <= 5">Username requires at least 5 characters</p>
        <label class="col-2" :style="{ color: [colors.description] }">Password: <input class="border-1 form-control-lg" v-model='password' type="password" name="password"></label><br />
        <p :style="{ color: [colors.danger_text]}" class="d-flex justify-content-center" v-if="danger_password && password.length <= 5">Username requires at least 8 characters</p>
        <div class="mb-3">
          <div class="form-check" v-if="user_data.role == 'admin'">
            <label class="form-check-label" :style="{ color: [colors.description] }">
              Admin:
            </label>
            <input class="form-check-input mx-2" type="checkbox" v-model="role_checkbox" disabled v-if="id_ == 1 || user_data.user_id != 1">
            <input class="form-check-input mx-2" type="checkbox" v-model="role_checkbox" v-else>
          </div>
        </div>
</form>
<div class="modal-footer">
    <button type="button" class="btn" @click="onReturn()" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Cancel</button>
    <button type="button" class="btn" @click="editUser()" :style="{ background: [colors.button_accept], color: [colors.button_accept_text]}">Save</button>
</div>
</div>
<!--<img :src="image" />-->

    `,
    data: function () {
        return {
            colors: color.data,
            users: users.data,
            user_selected: false,
            id_: 0,
            username: "",
            password: "",
            role: "",
            role_checkbox: false,
            danger_username: false,
            danger_password: false,
        }
    },
    created: async function() {
        await loadColors();
        this.colors = color.data;
        },
    methods: {
        // Applies the data of the current logged in user
        getThisUser(){
            this.user_selected = true;
            this.id_ = this.user_data['user_id'];
            this.username = this.user_data['username'];
            this.role = this.user_data['role'];
            this.role_checkbox = this.role === "admin";
        },
        // Applies the data of a user selected
        getUserData(user){
            this.user_selected = true;
            this.id_ = user['user_id'];
            this.username = user['user_name'];
            this.role = user['user_role'];
            this.role_checkbox = this.role === "admin";
        },
        onReturn() {
            this.user_selected = false;
            this.id_ = 0;
            this.username = "";
            this.role = "";
        },
        // Request and update to a user with the given information
        editUser: async function () {
            if (this.password.length >= 8 && this.username.length >= 5 && isUser()) {
            if (!this.role_checkbox) {
                this.role = 'staff'
            } else {
                this.role = 'admin'
            }
            let request = await fetch("/user", {
                method: 'PUT',
                headers: {"Content-Type": "application/json"},
                body: JSON.stringify({
                    'id': this.id_,
                    'username': this.username,
                    'password': this.password,
                    'role': this.role,
                })
            });
            if (request.status === 200) {
                showMessage("User updated!");
                this.reset();
                await getUsers();
                $('#editUserModal').modal('hide');
            }
            } else {
                if (this.password.length <= 8) {
                    this.danger_password = true;
                }
                if (this.username.length <= 5) {
                    this.danger_username = true;
                }
            }
        },
        reset(){
            this.user_selected = false;
            this.id = 0;
            this.username = "";
            this.password = "";
            this.role = false;
        },
    },
    computed: {
        user_data: function() {
            return user.data
        }
    }

};

//Flash remove message
//Add search function*
//Confirmation popup on change

//Disable 'save' button when conditions isn't met

//Only head admin should be allowed to edit any user
//Admin should only be allowed to edit staff users
//Staff should only be allowed to edit their own accounts