const removeUserC = {
    props: [],
    template: `
<div id="selectUser" v-if="!user_selected">
    <ul class="list-group">
    <label class="list-group-item" v-for="user in users.users" :style="{ background: [colors.settings_list]}" v-show="user.user_id != 1 || (user_data.role == 'admin' && user.role == 'staff')">
        <a href="#" class="nav-link" @click="getUserData(user)" :style="{ color: [colors.settings_text]}">
          {{ user.user_name }}
        </a>
    </label>
    </ul>
</div>
<div id="removeUser" class="" v-if="user_selected">
<form @submit.prevent @submit="editUser()">
        <div class="mb-3">
          <div class="form-check">
            <label :style="{ color: [colors.description] }">Username:</label><br />
            <h4 class="col-2" :style="{ color: [colors.title] }">{{username}}</h4>
            <label :style="{ color: [colors.description] }">Staff:</label><br />
            <h5 class="col-2" v-if="role == 'admin'" :style="{ color: [colors.title] }">Admin</h5>
            <h5 class="col-2" v-else :style="{ color: [colors.title] }">Staff</h5>
          </div>
        </div>
    </form>
<div class="modal-footer">
    <button type="button" class="btn" @click="onReturn()" :style="{ background: [colors.button_cancel], color: [colors.button_cancel_text]}">Cancel</button>
    <button type="button" class="btn" @click="deleteUser()" :style="{ background: [colors.danger], color: [colors.danger_button_text]}">Delete User</button>
</div>
</div>
<!--<img :src="image" />-->

    `,
    data: function () {
        return {
            colors: color.data,
            users: users.data,
            user_selected: false,
            id: 0,
            username: "",
            role: false,

        }
    },
    created: async function() {
        await loadColors();
        this.colors = color.data;
    },
    methods: {
        //Gets data of the user clicked on
        getUserData(user){
            this.user_selected = true;
            this.id = user['user_id'];
            this.username = user['user_name'];
            this.role = user['user_role'] === 'admin';

        },
        //Resets variables if selected user is cancelled
        onReturn() {
            this.user_selected = false;
            this.id = 0;
            this.username = "";
            this.role = "";
        },
        // Sends a delete request of a user id and deletes the user from the database
        deleteUser: async function () { //Removes user for user table
            if (isUser() && this.user_data.user_id !== this.id) {
                let request = await fetch("/user/"+this.id, {
                    method: 'delete',
                });
                if (request.status === 200) {
                    showMessage("User deleted..");
                    this.reset();
                    await getUsers();
                    $('#removeUserModal').modal('hide');
                }
            } else {
                showMessage("You cannot delete this account!", false)
            }
        },
        reset(){
            this.user_selected = false;
            this.id = 0;
            this.username = "";
            this.password = "";
            this.role = false;
        },
    },
    computed: {
        user_data: function() {
            return user.data
        }
    }

};

//Display Username and role which is not in a input field

//HeadAdmin role should not be able to be deleted, only change username/password
//Staff should not be able to access other users, only itself
//Confirmation popup

//Head admin cant be deleted